#include "stdafx.h"
#include "yaneObjectCreater.h"
#include "../Auxiliary/yaneFile.h"

//////////////////////////////////////////////////////////////////////////////

#if !defined(NOT_USE_DEFAULT_DLLMAIN) && defined(COMPILE_YANE_PLUGIN_DLL)
namespace {
CAppInitializer* g_pAppInit;
}

BOOL APIENTRY DllMain( HANDLE hModule,  // HINSTANCEł
					   DWORD  ul_reason_for_call, 
					   LPVOID lpReserved
					 )
{
	//	QDDllMainł́ACAppInitializerŏ郈VI

	switch (ul_reason_for_call) {
		case DLL_THREAD_ATTACH :
			   {
				g_pAppInit = new CAppInitializer(hModule,ul_reason_for_call,lpReserved);
				//	KvȂ炱ɏȂ胈
				//	ӎ
				//	D̎_ł͂܂new/delete͎gȂ(ȉ5.̊֐ōsȂ)
				//	DErrfoCX͖(KvȂ΁Aȉ5.̊֐ōsȂ)
			   }
			break;
		case DLL_THREAD_DETACH :
			   {
				if (g_pAppInit!=NULL) { delete g_pAppInit; g_pAppInit=NULL; }
			    //	I͂ɏă`
				//	Ƃ΁A5.̊֐newstaticȃ|C^
				//	delete鏈ƂB
			   }
		   break;
	};
	return TRUE;
}
#endif

#ifdef COMPILE_YANE_PLUGIN_DLL

#include "../AppFrame/yaneAppInitializer.h"
#include "../Auxiliary/yaneStream.h"
//	́ȀyaneSDK3rdCuŜɑ΂鏉KvȂ̂
//	includeĂłBCObjectCreaterԂʂƂ́AĂB

//	vg^Cv錾OOG
void	YaneRegistPlugIn(IObjectCreater*);
//	̊֐ADLL PlugInƂāAR[obNĂ炤
extern "C"	__declspec( dllexport ) void _cdecl YaneDllInitializer(void*p){
	IObjectCreater* pObjectCreater = static_cast<IObjectCreater*>(p);
	IObjectCreater::SetObj(pObjectCreater);	//	o^

	//	yaneSDK3rd̂Ȃŏ(staticȕϐ)KvȂ̂͂ŏ
	//	DLLł́ASetObj܂new/deletegȂ̂ŎdȂ̂ł
	//	CObjectCreater̃\[XԂʂƂ͍폜Ă͂
	///////////////////////////////////////////////////////////////////
	CFile::SetCurrentDir();	//	CFilepath
#ifdef USE_ErrorLog		//	CErrorLogNXLɂB
	//	G[o̓foCXЂƂp
	Err.SelectDevice(smart_ptr<ITextOutputStream>(new CTextOutputStreamNullDevice));
#endif
	///////////////////////////////////////////////////////////////////

	//	user`
	YaneRegistPlugIn(pObjectCreater);
}

//	newdeletéAMain̂̂Ă
void* operator new (size_t t){
	IObjectCreater* pp = IObjectCreater::GetObj();
	if (pp!=NULL){
		return pp->New(t);
	} else {
		WARNING(true,"operator newIObjectCreaterOɌĂяoĂ");
		return (void*)malloc(t);	//	ƂĂϽް(߄D)
	}
}

void operator delete(void*p){
	IObjectCreater* pp = IObjectCreater::GetObj();
	if (pp!=NULL){
		pp->Delete(p);
	} else {
		WARNING(true,"operator deleteIObjectCreaterIɌĂяoĂ");
		::free(p);					//	ƂĂϽް(߄D)
	}
}
#endif

namespace yaneuraoGameSDK3rd {
namespace AppFrame {

//	DLL?
#ifdef COMPILE_YANE_PLUGIN_DLL
//	static member..
IObjectCreater* IObjectCreater::m_p;
#endif

CDllPlugInLoader::CDllPlugInLoader(){
	m_hDll = NULL;
}
CDllPlugInLoader::~CDllPlugInLoader(){
	Release();
}

LRESULT CDllPlugInLoader::Load(const string& szDllName){
	m_strFileName = szDllName;
	// DLLǂݍ
	m_hDll = ::LoadLibrary(m_strFileName.c_str());
	if(m_hDll==NULL){
		Err.Out("CDllPlugInLoader::Load \"%s\"̃[hɎs", m_strFileName.c_str());
		return 1;
	}
	return 0;
}

LRESULT CDllPlugInLoader::Release(){
	LRESULT lr=0;
	if(m_hDll!=NULL){
		lr = !::FreeLibrary(m_hDll);
		m_hDll = NULL;
	}
	return lr;
}

//////////////////////////////////////////////////////////////////////////////

//	static member..
singleton<CObjectCreater> CObjectCreater::m_vObj;

CObjectCreater::CObjectCreater(): m_pPlugInInfo(0){}

void* CObjectCreater::Create(LPCSTR strClassName){
	void* pObj=NULL;
	CCriticalLock cl(GetCriticalSection());
	{
		smart_vector_ptr<CObjectInfo>& info = *GetObjectInfo();
		smart_vector_ptr<CObjectInfo>::iterator it = info.begin();
		while (it!=info.end()){
			if ((*it)->strClassName==strClassName){
			//	[II
			//	factoryĂяoăIuWFNgĕԂŁII
				//if (it->factory_base!=NULL){
				//	NULLł邱Ƃ͂肦Ȃ
					pObj = (*it)->factory->Create();
					break;
				//}
			}
			++it;
		}
	}
	return pObj;
}

LRESULT CObjectCreater::LoadPlugIn(LPCSTR strFileName){
	LRESULT lr=0;
	const string str(CFile::MakeFullName(strFileName));
	//	AMakeFullNameAFindFilêقǂ̂...

	CCriticalLock cl(GetCriticalSection());
		//	plug inT
		smart_vector_ptr<CPlugInInfo>::iterator	it = FindPlugIn(str);
		if (it == GetPlugInInfo()->end()) {
			//	ǂݍŁÃNXifactoryjo^
			m_pPlugInInfo = new CPlugInInfo;
			//	̕ϐ́ADLLQƂꂤ
			if (m_pPlugInInfo->vPlugIn.Load(str)==0){	
			//	plug-inǂݍ݂ɐ
				HINSTANCE hDll = m_pPlugInInfo->vPlugIn.GetInstance();
				typedef void (_cdecl *Func)(void*);
				Func YaneDllInitializer = (Func)::GetProcAddress(hDll, "YaneDllInitializer");
				if(YaneDllInitializer==NULL){
					//	sS
					DELETE_SAFE(m_pPlugInInfo);
				} else {
					//	L̈ړ
					YaneDllInitializer(static_cast<void*>(this));
					GetPlugInInfo()->insert(m_pPlugInInfo);
					m_pPlugInInfo = NULL;	//	deleteĂ͂
				}
			} else {
				DELETE_SAFE(m_pPlugInInfo);
			}
		} else {
			//	ɓǂݍł̂ŁA̎QƃJEĝ݂Z
			(*it)->nRef++;
		}
	return lr;
}

LRESULT CObjectCreater::ReleasePlugIn(LPCSTR strFileName){
	LRESULT lr=0;

	const string str(CFile::MakeFullName(strFileName));
	//	AMakeFullNameAFindFilêقǂ̂...

	CCriticalLock cl(GetCriticalSection());
		//	plug inT
		smart_vector_ptr<CPlugInInfo>::iterator	it = FindPlugIn(str);
		if (it == GetPlugInInfo()->end()) {
			//	Ƃ́AǂH
			Err.Out("CObjectCreater::ReleasePlugIn o^ĂȂPlugIn̍폜");
		} else {
			//	QƃJEgZ
			if (--(*it)->nRef == 0){
				//	0ɂȂ̂ŁÃIuWFNgdelete
				CPlugInInfo* pInfo = (*it).get();
				//	pInfopĂIuWFNg
				//	factoryo^Ȃ΂ȂȂ
				smart_vector_ptr<CObjectInfo>::iterator it2	= GetObjectInfo()->begin();
				while (it2!=GetObjectInfo()->end()){
					if ((*it2)->pPlugIn == pInfo){
						it2 = GetObjectInfo()->erase(it2);
					} else {
						++it2;
					}
				}
				GetPlugInInfo()->erase(it);	//	smart_ptrȂ̂ŁAŏ
			}
		}
	return lr;
}

smart_vector_ptr<CObjectCreater::CPlugInInfo>::iterator
	CObjectCreater::FindPlugIn(const string& strPlugInName){
/*
	̊֐́A
		LRESULT CObjectCreater::LoadPlugIn  ReleasePlugIn
	ĂяôŁACriticalSectionłƉ肵ėǂ
*/
	smart_vector_ptr<CPlugInInfo>::iterator	it = GetPlugInInfo()->begin();
	smart_vector_ptr<CPlugInInfo>::iterator it_end	= GetPlugInInfo()->end();
	while (it!=it_end){
		if (strPlugInName == (*it)->vPlugIn.GetFileName())
			break;
		++it;
	}
	return it;
}

void CObjectCreater::RegistClass(LPCSTR strClassName,factory_base*f){
	CObjectInfo* pInfo = new CObjectInfo;
	pInfo->pPlugIn		= m_pPlugInInfo;
	pInfo->strClassName = strClassName;
	pInfo->factory		= f;
	GetObjectInfo()->insert(pInfo);
}


void* CObjectCreater::New(size_t t){
	return new BYTE[t];
}

void  CObjectCreater::Delete(void* p){
	delete [] p;
}

} // end of namespace AppFrame
} // end of namespace yaneuraoGameSDK3rd
