
#ifndef __yaneAllocator_h__
#define __yaneAllocator_h__
#include "../Thread/yaneLockObject.h"

namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

class IMemoryAllocator {
/**
	蓖ėp
*/
public:
	virtual	BYTE* Alloc(int size) = 0;
	/**
		sizeoCg̃allocāA̐擪AhXԂ
		size==0̂Ƃ́ANULL|C^Ԃ
	*/

	virtual void Free(BYTE* pb) = 0;
	/**
		AllocŊmۂԋp
		ԋpłȂƂ͖̓`
	*/

	virtual ~IMemoryAllocator() {}
};

class CMemoryAllocatorPool : public IMemoryAllocator {
/**
	蓖ėp@ėpNX
	X^bN̈Ɋmۂɑ΂AP[^肽ƂȂǂɎg
	o͈ꉞthread safełB

	gpj
		BYTE stack1024[1024];
		CMemoryAllocatorPool pool;
		pool.SetMemory(&stack1024[0],1024); // stack1024̃v[

		BYTE* p = pool.Alloc(1024);	//	v[ꂽ犄蓖

*/
public:
	void	SetMemory(BYTE*pb,int size) {
		synchronized guard(cs_);
		Release();
		memory_.push_back(CMemoryTable(pb,size,false));
	}
	/**
		\ߊmۂꂽAZbgĂ΁Aȍ~
		Allocł͂̃ォ̈mۂB
		SetMemoryĂȂԂAllocsȂƂA
		Allocŏ\ȃmۂłȂƂCRuntimeExceptionthrow
	*/

	void	Release() { synchronized guard(cs_); memory_.clear(); }
	/**
		mۂĂ郁񓙂Zbg
	*/

	//	overridden from IMemorAllocator
	virtual	BYTE* Alloc(int size);
	virtual void Free(BYTE* pb);

	CMemoryAllocatorPool() { Release(); }
	virtual ~CMemoryAllocatorPool() {}
	// ̗̈悪ΗOX[ƂĂ?


protected:
	struct CMemoryTable {
		CMemoryTable(BYTE*start,int size,bool bUsed) :
			start_(start),size_(size),bUsed_(bUsed){}
		BYTE* start_;	//	擪
		int	  size_;	//	TCY(Pʂ̓oCg)
		bool  bUsed_;	//	gpĂ邩ǂ̃tO
	};

	typedef list<CMemoryTable>mylist;
	mylist memory_;
	//	ꂪmۂ\

	CCriticalSection cs_;
};

} // end of namespace Auxiliary
} // end of namespace yaneuraoGameSDK3rd

#endif
