// yaneDir.h :
//
//		directory file wrapper
//
//			programmed by yaneurao(M.Isozaki) '99/10/19 - '99/11/28
//

#ifndef __yaneDir_h__
#define __yaneDir_h__


namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

class CDir {
public:
	//	Directory
	void	SetFindFile(const string& file);					//	t@Cݒ
	void	SetPath(const string& file);						//	pXݒ
	void	EnableSubdir(bool b) { m_bSubDir = b; }				//	̂ƂɃTutH_Lɂ̂
	void	EnablePackFile(bool b) { m_bPackFile = b; }			//	yanePackt@CΏۂɂ̂H

	LRESULT	FindFile(string& file);								//	t@C擾(ԂlOȂNot Found)
	static bool IsMatch(LPCSTR it1,LPCSTR it2);					//	̕񂪈v邩H(wildcardgp\)
	void	Reset() { CloseFindFile(); }

	void	EnableDirListup(bool b) { m_bAllFile = b; }			//	tH_}b`OΏۂɂ
	bool	IsDir() const { return m_bDir; }				//	FindFileŎ擾̂̓tH_H

	bool	IsFileExist(const string& file);					//	̃t@C݂͑̂H

	//	Drives
	DWORD	CheckDrive() { return m_dwDrive=::GetLogicalDrives(); }
	bool	IsExistDrive(int n) const { return (m_dwDrive & (1L << n))!=0; }

	CDir();
	virtual ~CDir();

protected:
	void	CloseFindFile();								//	I
	string	m_file;			//	t@C
	string	m_path;			//	path
	HANDLE	m_handle;		//	nh
	bool	m_bSubDir;		//	subdirLH	
	bool	m_bPackFile;	//	packfileLH	
	CDir*	m_lpDir;		//	subdirp(ċAIɗp)

	//	tH_̃XgAbvp
	bool	m_bAllFile;		//	tH_Ώۂɂ̂H
	bool	m_bDir;			//	܎擾̂̓tH_H

	//	kt@Cp
	HANDLE	m_hPackFile;	//	kt@Cpnh
	DWORD	m_dwFileNum;	//	kt@Ct@C
	int		m_nPackFile;	//	kt@C 0:yanePack 1:yanePackEx 2:yanePackDx
	string	m_PackName;		//	̈kt@C
protected:
	DWORD	m_dwDrive;
};

} // end of namespace Auxiliary
} // end of namespace yaneuraoGameSDK3rd

#endif
