#include "stdafx.h"
#include "yaneStringScanner.h"

namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

bool	CStringScanner::IsToken(LPCSTR &lp,LPCSTR lp2){
	if (lp2==NULL) return false;

	LPCSTR lpx = lp;
	//	ŁAXy[XA^u΂ėǂƎv
	SkipSpace(lpx);
	while (true){
		if (*lp2=='\0') {
			//	ׂĈvI
			lp = lpx;	// |C^i߂I
			return true;
		}
		if (toupper(*(lpx++))!=toupper(*(lp2++))) return false;	//	_...
	}
}

LRESULT	CStringScanner::SkipTo(LPCSTR &lp,LPCSTR lp2){
	while (true){
		if (*lp=='\0') { //	EOFɏo킵I
			return 1;
		}
		//	if (IsToken(lp,lp2)) break;	//	ACCWJقȂ...
		//	xȂ̂Ł蓮ŃCCWJOOG
		{
			LPCSTR lpx = lp;
			LPCSTR lpx2 = lp2;
			while (true){
			if (*lpx2=='\0') {
				lp = lpx;	// |C^i߂I
				return 0;	//	vŏI
			}
				if (*(lpx++)!=*(lpx2++)) break;	//	_...
			}
		}
		lp++;
	}
	return 0;
}

//	́AvɈv܂łɃXLbv𕶎obt@ɃRs[
LRESULT	CStringScanner::SkipTo2(LPCSTR &lp,LPCSTR lp2,LPSTR lp3){
	LPCSTR lp_org = lp;
	while (true){
		if (*lp=='\0') { //	EOFɏo킵I
			return 1;
		}
		//	if (IsToken(lp,lp2)) break;	//	ACCWJقȂ...
		//	xȂ̂Ł蓮ŃCCWJOOG
		{
			LPCSTR lpx = lp;
			LPCSTR lpx2 = lp2;
			while (true){
			if (*lpx2=='\0') {
				//	obt@ɃRs[ĂB
				int nSize = lp - lp_org;
				::CopyMemory(lp3,lp_org,nSize);
				*(lp3+nSize) = '\0';

				lp = lpx;	// |C^i߂I
				return 0;	//	vŏI
			}
				if (*(lpx++)!=*(lpx2++)) break;	//	_...
			}
		}
		lp++;
	}
	return 0;
}

LRESULT CStringScanner::SkipSpace(LPCSTR &lp){
	//	Xy[XA^uAs؂l߂
	while (*lp==0x0a || *lp==0x0d || *lp==' ' || *lp=='\t'){
		lp++;
	}
	if (*lp=='\0') return 1;
	return 0;
}

LRESULT CStringScanner::SkipSpace2(LPCSTR &lp){
	//	Xy[XA^uAJ}As؂l߂
	//	csvǂݍ݂Ɏgƕ֗
	while (*lp==0x0a || *lp==0x0d || *lp==' ' || *lp=='\t' || *lp==','){
		lp++;
	}
	if (*lp=='\0') return 1;
	return 0;
}

LRESULT	CStringScanner::GetStrNum(LPCSTR &lp,int& nRate){
//	"+1"ƂȂnRateɂ1Ԃ
	if (SkipSpace(lp)!=0) return -1;	//	_

	if (*lp!='"') return 3;	//	[I
	lp++;
	nRate = 0;
	int nSign = 1;
	if (*lp=='+') { lp++; }
	ef (*lp=='-') { nSign = -1; lp++; }
	LRESULT lr = 1;
	while (*lp>='0' && *lp<='9') {
		lr = 0;
		nRate = nRate*10+(*lp-'0');
		lp++;
	}
	nRate *= nSign;
	if (*lp!='"') return 3; // ĂȂ
	lp++;
	return lr;
}

LRESULT	CStringScanner::GetNum(LPCSTR &lp,int& nVal){
//	+1ƂȂnValɂ1Ԃ

	if (SkipSpace(lp)!=0) return -1;	//	_

	nVal = 0;
	int nSign = 1;
	if (*lp=='+') { lp++; }
	ef (*lp=='-') { nSign = -1; lp++; }
	LRESULT lr = 1;
	while (*lp>='0' && *lp<='9') {
		lr = 0;
		nVal = nVal*10+(*lp-'0');
		lp++;
	}
	nVal *= nSign;
	return lr;
}

LRESULT CStringScanner::GetStrColor(LPCSTR &lp,COLORREF& nFontColor){
// "#ff0000"ƂȂRGB(255,0,0)Ԃ
	if (SkipSpace(lp)!=0) return -1;

	if (*lp!='"') return 3;	//	[I
	lp++;
	if (*lp!='#') return 3; // #T|[gĂȂ̂OOG
	lp++;
	LRESULT lr = 1;
	DWORD dw = 0;
	while ((*lp>='0' && *lp<='9')||(*lp>='a' && *lp<='f')||(*lp>='A' && *lp<='F')){
		lr = 0;
		int c;
		if (*lp>='0' && *lp<='9') {
			c = *lp - '0';
		} else {
			c = toupper(*lp) - 'A'+10;
		}
		dw = (dw << 4) + c;
		lp++;
	}
	if (*lp!='"') return 3; // ĂȂ
	lp++;
	//	RGB͓]uVn
	nFontColor = ((dw & 0xff)<<16) + (dw & 0xff00) + ((dw & 0xff0000)>>16);
	return lr;
}

string CStringScanner::GetStr(LPCSTR &lp,CHAR c){
	//	cɑƂ܂ł̕Ԃ
	string str;
	while ( *lp!=c && *lp != NULL ) {
		str += *(lp++);
	}
	return str;
}

string CStringScanner::GetStr(LPCSTR &lp){
	//	Xy[XA^uAsɑƂ܂ł̕Ԃ
	//	SpΉOOG
	string str;
	while (true) {
		CHAR c = *lp;
		if (c==' ' || c=='\t' || c=='\0' || c=='\n') break;
		str += c;
		lp++;
	}
	return str;
}

string CStringScanner::GetStrFileName(LPCSTR &lp){
	//	^uAsɑƂ܂ł̕Ԃ
	//	SpΉOOG
	string str;
	while (true) {
		CHAR c = *lp;
		if (c=='\t' || c=='\0' || c=='\n') break;
		str += c;
		lp++;
	}
	return str;
}

string CStringScanner::GetNextStr(LPCSTR &lp){
	//	Xy[XA^uAsɑƂ܂ł̕Ԃ
	//	SpΉOOG
	string str;
	if (SkipSpace(lp)!=0) return str;	//	_ˁ`OOG

	bool bDC = (*lp == '"');	//	_uR[eŎn܂Ă邩H
	if (bDC) lp++;

	while (true) {
		CHAR c = *lp;
		if (bDC) {	//	_uR[eX^[gȂ΃Xy[XC^u͖
			if (c=='"' ) { lp++;break;};
			if (c=='\0') break;
		} else {
			if (c==' ' || c=='\t' || c=='\0' || c=='\n') break;
		}
		str += c;
		lp++;
	}
	return str;
}

LRESULT CStringScanner::GetNumFromCsv(LPCSTR &lp,int& nVal,bool b){
	//	J}AXy[X𖳎Ȃ琔lǂݍނ̂
	if ( !b ){
		if (SkipSpace2(lp)!=0) return 1;
		if (GetNum(lp,nVal)!=0) return 2;
	}else{
		if ( *lp==',' || *lp== '\t' || *lp=='/' ) {
			lp++;
			nVal = 0;
		}else{
			LRESULT lr = GetNum(lp,nVal);
			if ( *lp==',' || *lp== '\t' || *lp=='/' ) {
				lp++;
			}
			if ( lr != 0 ) return 2;
		}
	}
	
	return 0;
}


string CStringScanner::GetStrFromCsv(LPCSTR &lp){
	string str;
	while ( *lp!=',' && *lp!='/' && *lp != NULL ) {
		str += *(lp++);
	}
	return str;
}

void	CStringScanner::Replace(string& buf,LPCSTR pSrc,LPCSTR pDst,bool bCaseSensitive){
	//	stringɊ܂܂pSrcƈv镔pDstɒu
	//	{ΉBbCaseSensitive==truêƂ́A
	//	At@xbg̑啶ʂB

	//	u񂪋H
	if (buf.empty()) return ;

	//	u\[X󔒁H
	if (*pSrc == '\0') return ; // ͂DD
	
	LPCSTR pSz = buf.c_str();
	LPCSTR pSzOrg = pSz; // IWi|WV
	while (*pSz!='\0'){
		//	啶ƏʂƂ
		if ((bCaseSensitive && *pSz == *pSrc) ||
			(!bCaseSensitive && toupper(*pSz)==toupper(*pSrc))){
			//	擪vŁAv邩ׂɂ
			LPCSTR p1 = pSz+1;
			LPCSTR p2 = pSrc+1;
			while(true) {
				if (*p2=='\0'){
				//	vOOG
					goto Found;
				}
				//	啶ƏʂƂ
				if (bCaseSensitive){
					if (*p1!=*p2) break;
					p1++; p2++;
				} else {
				//	啶ƏʂȂƂ
					int c = *p1;
					if (toupper(c)!=toupper(*p2)) break;
					if (IsLead_ShiftJIS(c)){
						p1++; p2++;
						if (*p1!=*p2) break;
						//	R[ĥQoCgڂɂCaseInsensitivityKpȂ
						p1++; p2++;
					} else {
						p1++; p2++;
					}
				}
			}
		}
		//	}`oCg΍
		if (IsLead_ShiftJIS(*pSz)){
			pSz+=2;
		} else {
			pSz++;
		}
	}
	return ;

Found:;
	vector <int> an;
	an.push_back(pSz-pSzOrg); //	݈ʒu(0IW)
	int nL1 = ::strlen(pSrc);
	int nL2 = ::strlen(pDst);
	pSz+= nL1; // v񕪂Z

	//	Ɍ𑱂
	while (*pSz!=0){
		//	啶ƏʂƂ
		if ((bCaseSensitive && *pSz == *pSrc) ||
			(!bCaseSensitive && toupper(*pSz)==toupper(*pSrc))){
			//	擪vŁAv邩ׂɂ
			LPCSTR p1 = pSz+1;
			LPCSTR p2 = pSrc+1;
			while(true) {
				if (*p2=='\0'){
				//	vOOG
					an.push_back(pSz-pSzOrg); //	݈ʒu(0IW)
					pSz+= nL1; // v񕪂Z
					goto SearchNext;
				}
				//	啶ƏʂƂ
				if (bCaseSensitive){
					if (*p1!=*p2) break;
					p1++; p2++;
				} else {
				//	啶ƏʂȂƂ
					int c = *p1;
					if (toupper(c)!=toupper(*p2)) break;
					if (IsLead_ShiftJIS(c)){
						p1++; p2++;
						if (*p1!=*p2) break;
						//	R[ĥQoCgڂɂCaseInsensitiveKpȂ
						p1++; p2++;
					} else {
						p1++; p2++;
					}
				}
			}
		}
		//	}`oCg΍
		if (IsLead_ShiftJIS(*pSz)){
			pSz+=2;
		} else {
			pSz++;
		}
SearchNext:;
	}

	//	ۂ̏kg
	int n = pSz-pSzOrg; // ̕
	int m = an.size();
	int nL = n + m*(nL2-nL1) + 1; // u鐔~P̕ψ + 1(I[NULL)
	LPSTR pTmp = new CHAR[nL];
	//	nL1==nL2̂Ƃ́Ãobt@쐬Ƃ͂͂̂A
	//	string::c_stŕAconstȃobt@Ȃ߁AύX͋ĂȂ
	LPSTR pTmpt = pTmp;
	pSz = pSzOrg;
	int k=0;
	for(int i=0;i<n;i++){
		if ((k<m) && (i==an[k])){ // if ̕]͍Ɖ肵Ă
			LPCSTR pDstt = pDst;
			while (*pDstt!='\0'){
				*(pTmpt++) = *(pDstt++);
			}
			i += nL1-1;
			pSz += nL1; // \[XZ
			k++;
		} else {
			*(pTmpt++) = *(pSz++);
		}
	}
	*pTmpt = '\0'; // I[
	buf = pTmp; // ̑
	delete [] pTmp;
}

void	CStringScanner::NumToString(LONGLONG l,string& s){
	if (l==0) {
		s = "0";
		return ;
	}
	bool bMinus;
	if (l<0) {
		bMinus = true;
		l = -l;
	} else {
		bMinus = false;
	}
	s.erase();
	while (l!=0){
		s = (CHAR)((l%10) + '0') + s;
		//	ꂽR[ĥ..
		l/=10;
	}
	if (bMinus) {
		s = '-' + s;
	}
}

LRESULT	 CStringScanner::StringToNum(string s,LONGLONG& l){
	LPCSTR psz = s.c_str();
	bool bMinus;
	if (*psz == '-') {
		psz++;
		bMinus = true;
	} else {
		bMinus = false;
	}
	l=0;
	bool bFirst = true;
	while (true){
		CHAR c = *psz;
		if (c>='0' && c<='9'){
			l = l*10 + c-'0';
			bFirst = false;
		} else {
			if (bFirst){
			//	lPxsȂĂȂ
				return 1; // error
			}
			break;
		}
		psz++;
	}
	if (bMinus) l=-l;
	return 0;
}

void CStringScanner::NumToStringZ(LONGLONG l,string& s,int n){
	NumToString(l,s);
	int nLength = s.length();
	if (nLength < n){
		//	Ȃ̂ŁǍɃ[ǉB
		string t;
		for(int i=nLength;i<n;i++){ t+='0'; }
		s = t+s;
	} ef (nLength > n){
		//	̂ŁǍJbgiȕKv񂩁Hj
		s = s.substr(nLength-n,n);
	}
}

int	CStringScanner::CharToHex(CHAR n){
	if ('A'<=n && n<='F'){ n = n - 'A' + 10; }
	else if ('a'<=n && n<='f') { n = n - 'a' + 10; }
	else if ('0'<=n && n<='9') { n = n - '0'; }
	else {
#ifdef USE_EXCEPTION
		throw CRuntimeException();
#endif
	}
	return n;
}

CHAR CStringScanner::HexToChar(int n){
	if (n<0 || 15<n) {
#ifdef USE_EXCEPTION
		throw CRuntimeException();
#endif
	}
	if (n>=10){ n+='A'-10;} else { n+='0'; }
	return n;
}

LRESULT CStringScanner::Find(LPCSTR &lpSrc,LPCSTR lpMoji){
	if ( lpSrc == NULL || lpMoji==NULL || *lpMoji=='\0')
			return -1; // ȂnȁR(`DL)m
	while (*lpSrc != '\0') {
		if (*lpSrc == *lpMoji){
			int i=1;
			while (true){
				CHAR c = lpMoji[i];
				if (c=='\0') return 0; // matched
				if (c!=lpSrc[i]) break;	//	to next
				++i;
			}
		}
		++lpSrc;
	}
	return 1; //	not matched
}

bool CStringScanner::IsLead_ShiftJIS(CHAR c) {
	//	Optimize Technique No.004
	//	http://homepage1.nifty.com/herumi/adv/adv40.html
	return ((unsigned char)((c^0x20)-0xA1)<=0x3B)!=0;
}

bool CStringScanner::IsTrail_ShiftJIS(CHAR c){
	return ((0x40<=c&&c<=0x7e) || (0x80<=c&&c<=0xfc))!=0;
}

/////////////////////////////////////////////////////////////////////////////
CLineParser::CLineParser() {
	m_lpszReadData = NULL;										// 1Cǂݍ񂾃f[^
}

CLineParser::~CLineParser() {
}

void	CLineParser::SetLine( LPCSTR lpszStr ){
	m_lpszReadData = (LPSTR)lpszStr;
}

bool	CLineParser::IsMatch( LPCSTR lpszCmpStr ) {

	if ( m_lpszReadData == NULL ) return false;

	Garbage();				//	S~폜

	LPSTR lpOrg = m_lpszReadData;
	while ( true ) {
		if ( *lpszCmpStr == '\0' ) return true;
		if ( ::toupper( *(lpszCmpStr++) ) != ::toupper( *(m_lpszReadData++) ) ) {	//	w肵Ɠۂ̔
			m_lpszReadData = lpOrg;
			return false;
		}
	}
}


LRESULT		CLineParser::GetNum( int& nNo )
{
	if ( m_lpszReadData == NULL ) return 1;

	int		c;
	int		nRetNum = 0;
	bool	bSigned = false;

	Garbage();

	// w0`9xw-xT
	// ŏw-xw0`9xȊO̎GetNums
	c = *m_lpszReadData;
	if ( (c < '0' || c > '9') && (c != '-') ) return 1;

	if (c=='-') {
		bSigned = true;
		m_lpszReadData++;
	}

	while ( true ) {
		c = *m_lpszReadData;
		if ( (c >= '0') && (c <= '9') ) {
			nRetNum = nRetNum*10 + (c -'0');	//	𐔒lɂāAグ
		} else {
			break;
		}
		m_lpszReadData++;
	}

	if ( bSigned )												//	}CiXۂ̔
		nRetNum = -nRetNum;

	nNo = nRetNum;												//	ʂn
	return 0;
} // GetNum


LRESULT		CLineParser::GetStr( string& str )
{
	if ( m_lpszReadData == NULL ) return 1;

	Garbage();
	
	// w"xT
	// ŏw"xȊO̎GetStrs
	if ( *m_lpszReadData!= '\"' ) return 2;

	m_lpszReadData++;

	// ""܂ł̕n
	// Íw"xT
	CHAR	szStr[256];
	int		k=0;
	while (true) {
		int c = *(m_lpszReadData++);
		if (c=='\0') return 3;	//	unexpectedly terminate
		
		if (c=='\"') {
			szStr[k] = '\0';
			break;
		} else {
			szStr[k] = c;
		}
		k++;
	}

	str = (LPSTR) szStr;
	return 0;
} // GetStr


/////////////////////////////////////////

void	CLineParser::Garbage() {
	// S~ȊO܂Ń[v
	// S~w蕶 w (Space)xw	(Tab)xw,x
	while ( true )
	{
		int c = *m_lpszReadData;
		if ( c != ' ' && c != '\t' && c != ',' ) break;
		m_lpszReadData++;
	}
}

void	CLineParser::ConvertCR(LPSTR lpsz){
	LPSTR lp = lpsz;
	for(;;) {
		*lpsz = *lp;
		if (*lpsz == '\0') break;
		if((*lp == '\\') && (*(lp+1)=='n')) {
			*lpsz = '\n';
			lpsz++;
			lp+=2;
			continue;
		}
		lpsz++;
		lp++;
	}
}


} // end of namespace Auxiliary
} // end of namespace yaneuraoGameSDK3rd
