//
//	Dirty Rect (XV`)@ǗNX
//
//		programmed and designed by yaneurao '02/01/16

#ifndef __yaneDirtyRect_h__
#define __yaneDirtyRect_h__


namespace yaneuraoGameSDK3rd {
namespace Draw {

class IDirtyRect {
public:
	virtual void	Clear()=0;
	virtual void	Refresh()=0;
	virtual void	AddRect(int left,int top,int right,int bottom)=0;
	virtual void	AddRectSize(int x,int y,int sx,int sy)=0;
	virtual void	AddRect(const RECT& rc)=0;
	virtual int		GetRectNum() const=0;
	virtual LPCRECT	GetRect() const=0;

	virtual ~IDirtyRect(){}
};

class CDirtyRect : public IDirtyRect {
/**
	gB
		ClearŃNAB
		AddRectȂƂŁA`ZĂ
		i`悲ƂɊxƂȂJԂj
		̂ƂÃNX̓ŁAőXV`(dirty rect)
		Ȃ悤ɌĂBAʍ̏
		ȄXVȂ̂ɉʑŜőXV`(dirty rect)
		ƂđIĂ܂̂͂܂̂ŁÂ悤ȃP[XɂȂ
		ő5dirty rectĂǂƂɂB

		ŌARefreshĂяoƂɂAdi邢͊SɊ܂܂j
		dirty rectB

		āAGetRectNum,GetRectŁAdirty rect̐Ƌ`擾łB
*/
public:

	///	ׂĂNA
	void	Clear(){ m_nRectLast = 0; }

	///	tbV
	void	Refresh();

	///	`̉Z
	///		͈͎w^Cv
	void	AddRect(int left,int top,int right,int bottom);
	///		W{傫w^Cv
	void	AddRectSize(int x,int y,int sx,int sy)
	{	AddRect(x,y,x+sx,y+sy);}
	///		`ŉZ
	void	AddRect(const RECT& rc)
	{	AddRect(rc.left,rc.top,rc.right,rc.bottom); }

	//	--- property

	///	ʂ̎擾
	///		ꂽ`v(0:Ȃ)
	int		GetRectNum() const { return m_nRectLast; }
	///		ꂽ`ւ̃|C^擾
	LPCRECT	GetRect() const { return &m_arcRect[0]; }

	//	-----

	CDirtyRect() { Clear(); }

protected:
	enum	{ nRectSize = 5 };
	//	̐`m
	//	܂A܂ׂƂƁAK[xW̌̂
	//	5炢ɂĂB

	RECT	m_arcRect[nRectSize+1];	   //	`
	int		m_anRectArea[nRectSize+1]; //	`ʐ
	int		m_nRectLast;	//	܂ŎgĂ邩̃JE^
							//	==0 : gp
};

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd

#endif
