/**
	ISurface256{g₷I
*/

#ifndef __yanePlane_h__
#define __yanePlane_h__


namespace yaneuraoGameSDK3rd {
namespace Draw {

class ISurface;
class IPlaneFactory {
public:
	virtual ISurface* CreateInstance() = 0;
};

class CPlane {
/**
	smart_ptr<ISurface> Ƃ͖̂ʓ|ɂ܂Ȃ̂ŁDD
*/
public:
	///	|C^̂ӂ邽߂̎d|
	ISurface& operator*() const	 {return *get(); }
	ISurface* operator->() const {return get();	 }

	///	ISurfaceւ̈Öق̕ϊ
	operator ISurface* () const { return get(); }

	ISurface* get() const { return p_.get(); }

	//	default factory̐ݒ/擾
	static void SetFactory(const smart_ptr<IPlaneFactory>& pFactory) { pFactory_ = pFactory; }
	static smart_ptr<IPlaneFactory> GetFactory() { return pFactory_; }

	void	CreateInstance(const smart_ptr<IPlaneFactory>& pFactory);
	///	factorynΖIɃT[tF[X𐶐

	CPlane();
	/**
		́ASetFactoryĂfactory玩Isurface𐶐
	*/

	CPlane(const smart_ptr<IPlaneFactory>& pFactory);
	///	surfacefactoryn΁ApĐĕێ

	CPlane(const smart_ptr<ISurface>& surface);
	///	copy constructor

	CPlane(ISurface* surface);
	///@́ALCPlaneێ̂ŁA
	///		CPlane plane(new CTextFastPlane);
	///	̂悤ɂĎgƁI

protected:
	smart_ptr<ISurface> p_; // p_;@ċẮH
	static ThreadLocal<smart_ptr<IPlaneFactory> > pFactory_;	// default factory
};

class CFastDraw;
struct CPlaneFactoryFastPlane : public IPlaneFactory {
/**
	IPlaneFactoryhNXBCFastPlane𐶐邽߂factory
*/
	CPlaneFactoryFastPlane(CFastDraw*p) : pDraw_(p) {}
	virtual ISurface* CreateInstance();
protected:
	CFastDraw* pDraw_;
};

class CFastPlaneFactory {
/**
	̃NX́ARXgN^̂ȂŁA
	IPlaneFactoryhNXCPlaneɑ΂Đݒ肷
	ɂÃNXCAppɎ΁A
	̃Xbh́ACPlanéAׂCFastPlaneӖ邱ƂɂȂ
*/
public:
	CFastDraw*	GetDraw() { return m_vFastDraw.get(); }

	CFastPlaneFactory();

protected:
	smart_ptr<CFastDraw>	m_vFastDraw;	//	FastDrawĂ܂˂
};

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd

#endif
