//
//	yanePlaneLoader.h :
//
//		v[̓I[fBO
//

#ifndef __yanePlaneLoader_h__
#define __yanePlaneLoader_h__

#include "../Auxiliary/yaneLoadCache.h"
#include "../Draw/yaneSurface.h"
#include "../Draw/yanePlane.h"

namespace yaneuraoGameSDK3rd {
namespace Draw {

class CPlaneLoader : public CLoadCache {
/**
	class ISurface hNX̂߂ LoadCache

	ISurfacê߂factorýA
		CPlane::SetFactoryŐݒ肳ꂽ̂IɎgp
		(CPlaneLoader̃RXgN^CPlane::GetFactory)
		CPlane::SetFactoryŐݒ肳ꂽ̈ȊÔpȂ΁A
		CPlaneLoader::SetFactoryłƂݒ肷ΗǂB

	gp)
	CPlaneLoader pl;
	pl.SetReadDir("testplane/");	//	ǂݍpath̐ݒ
	pl.Set("planedefine.txt",true);

*/
public:

//	virtual smart_ptr<ISurface> GetPlane(int nNo);		///	v[̎擾
	virtual CPlane GetPlane(int nNo);		///	v[̎擾
	//	̂قg₷ĈB

	///	nNõt@C擾
	string	GetFileName(int nNo );

	/**
		F̐ݒ^擾
		̐FfBtHg̔FƂ
		ifBtHg= RGB(0,255,0)Ȃ킿)

		ӁFʗAT[tF[X̍(0,0)̓_𔲂FƂ邪A
			֐CPlaneLoaderł́AFŔF߂B
	*/
	void	SetColorKey(ISurfaceRGB rgb)
		{ m_rgbColorKey = rgb; m_bRGBColorKey = true; }
	ISurfaceRGB GetColorKey() const
		{ return m_rgbColorKey; }

	///	F́ARGBŎw肳Ă邩H
	bool	IsRGBColorKey() const { return m_bRGBColorKey; }

	///	FAʒuwŐݒ肷
	void	SetColorKeyPos(int x,int y)
	{	m_bRGBColorKey=false; m_nColorKeyPosX=x; m_nColorKeyPosY=y; }

	///	T[tF[Xfactoryݒ/擾(defaultłfactoryɂ
	///	CPlane::GetFactorŷĂ)
	void SetFactory(const smart_ptr<IPlaneFactory>& pFactory) { m_pPlaneFactory = pFactory; }
	smart_ptr<IPlaneFactory> GetFactory() { return m_pPlaneFactory; }

	CPlaneLoader();
protected:
	virtual	LRESULT InnerLoad(const smart_obj& obj);
	ISurfaceRGB m_rgbColorKey;
	bool	m_bRGBColorKey;		//	F́ARGBŎwȂ̂H
	int		m_nColorKeyPosX;
	int		m_nColorKeyPosY;
	smart_ptr<IPlaneFactory>  m_pPlaneFactory;
};

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd

#endif