//
//	yaneScene.h :
//
//		V[ǗNX
//		ˁ@˂炨z[y[WuV˃Q[vO}{MvXv
//			WCXCPPCPR͂Ql̂ƁB
//

#ifndef __yaneScene_h__
#define __yaneScene_h__


/**
	V[ǗNXBQ[ŕK{Bڂ́A
	˂炨z[y[WuV˃Q[vO}{MvXv
	WCXCPPCPR͂Ql̂ƁB

	PDISceneNXmediator瑽dpăV[NXĎgB
	QDISceneFactorymediatorƑdpĎgB
		smart_ptrCSceneControlɓnĂB

	Ƃ́APDō쐬IScenehNX̂ȂŁA
	ɍsV[w肷ΎRɃV[ԂړiWvER[j
	o܂B
*/

#include "../Auxiliary/yaneSerialize.h"

namespace yaneuraoGameSDK3rd {
namespace Draw {

class IScene;
class ISurface;		//	ۃT[tF[X

class ISceneFactory {
/**
	V[̍\ẑ߂parameterized factory
	́ÃNXhāAɓo^B
*/
public:
	virtual smart_ptr<IScene> CreateScene(int nScene) = 0;
	///	io[nScenẽV[NX𐶐ĕԂ
};

class ISceneParam {
/**
	V[ԂŃLb`{[邽߂̃p[^NXB
	hāALb`{[ƗǂB
*/
public:
	virtual ~ISceneParam(){}
};

class ISceneControl {
/**
	V[̃Rg[̊NX
*/
public:
	/// ------ V[̈ړ֘ABOnDraw^C~OŐ؂ւB
	///	iOnDrawł́ÃV[̕`͂Ȃj
	///	ɍsV[ݒ肷
	virtual void	JumpScene(int eScene)=0;
	///	V[R[iReturnSceneŁÃNXɖ߂Ăj
	///		ÃNX͂deleteB
	virtual void	CallScene(int eScene)=0;
	///	V[R[iReturnSceneŁÃNXɖ߂Ăj
	///		ÃNXdeleteꂸɎcB
	///		̃V[ɈڍsƂɁAOnCallSceneFastĂяoB
	virtual void	CallSceneFast(int eScene)=0;
	///	CallScene/CallSceneFastŌĂ΂ꂽV[ɕA
	virtual void	ReturnScene()=0;
	///	V[I
	virtual void	ExitScene()=0;
	/// --------------------------------------------------------------
	///	V[X^bNɐςށB
	///	(ReturnSceneƂɁAɐς܂ꂽiX^bNȂ̂ŋtj
	///	V[Ăяo)
	virtual	void	PushScene(int eScene) =0;
	///	PopScenełʔmȂǁA
	///	ł͐V[ǗƂ͌ȂCB(Jump֎~̘_)
	/// --------------------------------------------------------------
	///	--- `ƈړ͎̂Q̃tF[Yɕ遫
	///	IuWFNg̕`sȂ
	virtual void	OnDraw(const smart_ptr<ISurface>& lp)=0;
	///	IuWFNg̈ړs
	virtual void	OnMove(const smart_ptr<ISurface>& lp)=0;

	virtual void SetSceneFactory(const smart_ptr<ISceneFactory>& pv)=0;
	virtual smart_ptr<ISceneFactory> GetSceneFactory() const=0;
	virtual bool IsEnd() const=0;
	virtual int GetSceneNo() const=0;
	virtual smart_ptr<IScene> GetScene() const=0;
	virtual ~ISceneControl(){}
};

class CSceneControl : public ISceneControl , public IArchive {
/**
	class IScene iV[NXĵ߂̃Rg[[
*/
public:
	CSceneControl(const smart_ptr<ISceneFactory>& pvSceneFactory)
		{ SetSceneFactory(pvSceneFactory); }
	CSceneControl(){}
	/**
		RXgN^ł́At@Ng[n
		n˂ꍇ́ASetSceneFactoryœn
	*/
	virtual void SetSceneFactory(const smart_ptr<ISceneFactory>& pv)
		{ m_pvSceneFactory = pv;}
	virtual smart_ptr<ISceneFactory> GetSceneFactory() const
		{ return m_pvSceneFactory; }

	///	---	ȉ̐֐̈ӖISceneƓ
	virtual void	JumpScene(int nScene)
		{ m_nNextScene = nScene; m_nMessage=1; }
	virtual void	CallScene(int nScene)
		{ m_nNextScene = nScene; m_nMessage=2; }
	virtual void	CallSceneFast(int nScene)
		{ m_nNextScene = nScene; m_nMessage=3; }
	virtual void	ReturnScene(){ m_nMessage=4; }
	virtual void	ExitScene()	 { m_nMessage=5; }
	virtual void	PushScene(int nScene);
	virtual void	OnDraw(const smart_ptr<ISurface>& lp);
	virtual void	OnMove(const smart_ptr<ISurface>& lp);

	///	factoryݒ^擾łBCScenehNXA
	///		smart_ptr<IScene> p =
	///			GetSceneControl()->GetSceneFactory()->CreateScene(CSCENE1);
	///	̂悤ɂĂЂƂ̃V[𐶐Ă̂ȂŎqV[
	///	ĂяoƂoB

	///	----- property
	///	X^bNɌĂяoV[Ԃ
	///	ReturnSceneƂꂪtrueɂȂ
	virtual bool IsEnd() const;		//	ÎH

	///	݂̃V[io[Ԃ
	///	AIsEnd()==trueȂ΁A-1
	virtual int GetSceneNo() const;

	///	݂̃V[Ԃ
	///	AIsEnd()==trueȂ΁ANULLsmart_ptr߂
	virtual smart_ptr<IScene> GetScene() const;

protected:
	//	V[factory
	smart_ptr<ISceneFactory> m_pvSceneFactory;

	virtual void	CreateScene(int nScene);	//	V[̐iIɎgpj
	//	-----ړvbZ[W
	int		m_nMessage;
		//	0:No Message 1:JumpScene 2:CallScene
		//	3:CallSceneFast 4:ReturnScene 5:ExitScene
	int			m_nNextScene;
		//	ɈړׂV[

	class CSceneInfo {
	public:
		smart_ptr<IScene>	m_lpScene;		//	V[̃|C^
		int					m_nScene;		//	V[io[
		CSceneInfo() {
			m_nScene = -1;	//	CreateȂB
		}
	};
	//	ĂяoV[̃X^bN
	smart_vector_ptr<CSceneInfo>	m_SceneInfoStack;
	smart_vector_ptr<CSceneInfo>*	GetSceneStack()
		{ return &m_SceneInfoStack;}

	///	V[Ԃ̃f[^̂ƂɎgB
	smart_ptr<ISceneParam>	GetParam() const
		{ return m_vParam; }
	void	SetParam(const smart_ptr<ISceneParam>& vParam)
		{ m_vParam = vParam;}

	virtual void Serialize(ISerialize&){}
	///	ToDo:܂Ă[[BԂȂāA܂ĂȂ[B

private:
	///	V[Ԃ̂Ƃf[^̂ƂɎgBiƕ֗OOj
	smart_ptr<ISceneParam>	m_vParam;
};


class IScene : public IArchive {
/**
	V[NX

V[`
enum SCENE {
	SCENE1,			//	V[P
	SCENE2,			//	V[Q
};
*/
public:
	///	́A[U[KvɉăI[o[Ch邱
	virtual void	OnDraw(const smart_ptr<ISurface>& lp) {}
	virtual void	OnMove(const smart_ptr<ISurface>& lp) {}

	///	́Å֐ōsȂBiRXgN^łoutergȂ߁j
	virtual void	OnInit() {}

	///	CallScene/CallSceneFastŌĂяoA
	///	ReturnSceneŖ߂ĂƂɌĂяo
	///	nSceneɂ́Aǂ̃V[߂ĂB
	virtual void	OnComeBack(int nScene){}

	///	V[Rg[[̐ݒ^擾
	void	SetSceneControl(const smart_ptr<ISceneControl>& lp) { m_lpSceneControl = lp; }
	smart_ptr<ISceneControl> GetSceneControl() const { return m_lpSceneControl; }
	/// --------------------------------------------------------------
	virtual void Serialize(ISerialize&){}
	///	VACYKvȃNX́AI[o[ChĂ
	///	CSceneControlVACY@\񋟂Ă

	IScene(const smart_ptr<ISceneControl>& lp) : m_lpSceneControl(lp){}
	IScene() {}
	
	virtual ~IScene(){} // place holder

protected:

	smart_ptr<ISceneControl> m_lpSceneControl;
};

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd

#endif
