//	yaneChara.h :
//
//		Simple Sprite Manager
//		programmed by yaneurao '00/07/20
//		rewritten by yaneurao '03/06/18
//

#ifndef __yaneSprite_h__
#define __yaneSprite_h__

namespace yaneuraoGameSDK3rd {
namespace Draw {

class ISurface;

struct CSimpleSprite {
/**
	P̃XvCg\
	]T[tF[XƁA]`̏񂵂ȂB
*/
public:
	ISurface*	pSurface;	///	]v[
	RECT		rcRect;		///	]`
	// ---------- gΈȉ̂gĂ ----------
	int			nOx,nOy;	///	]ItZbg
	int			nHeight;	///	x[XCZop
	bool		bFast;		///	F]H

	//	---⏕
	void		set(ISurface*p);
	///	T[tF[XS̂̃XvCgƂ
	///	nOx=nOy=0,bFast=true,nHeight=sy

	void		set(ISurface*p,const RECT&rc);
	///	T[tF[Ẍꕔ̃XvCgƂ
	///	nOx=nOy=0,bFast=true,nHeight=sy

};

class CSprite {
/**
	CSimpleSpritevectorvectoroɎAXvCgNX

//		XvCgƂ́Auv[ɂ`v̏WƂ
//		`ł_\łāA`Ƃ͐؂藣člׂ
//
//		āÃNX͕`Ɋւ邱ƂsȂȂ

*/
public:
	///	XvCg̎
	typedef vector<CSimpleSprite> spritevector;
	typedef vector<spritevector> spritevectorofvector;

	///	XvCĝ̎擾
	spritevectorofvector* getAllSprite() { return m_vSprtieVector.get(); }
	spritevector* getDirectionalSprite()
		{ return &((*getAllSprite())[getDirection()]); }
	CSimpleSprite* getSprite()
		{ return &((*getDirectionalSprite())[getMotion()]); }

	///	X}[g|C^ł̎擾/ݒ(CSpriteChara擾Đݒ肷ׂ)
	smart_ptr<spritevectorofvector> getMySprite() { return m_vSprtieVector; }
	void	setMySprite(const smart_ptr<spritevectorofvector>& v)
		{ m_vSprtieVector = v; 	m_nDirection = m_nAnimation	= 0;}
	/**
		(*getAllSprite())[getDirection()][getMotion()]
		ʂɕ`悷̂łB

		m_nAnimation (getMotionŎ擾ł)̓Aj[VJE^Ȃ̂
		t[IɉZ
		m_nDirection (getDirectionŎ擾ł)́ALN^̌ύXB
		iƂɈÃAj[V`Ăƍl)

		L̕\́A
		(*getDirectionalSprite())[m_nAnimation]
		AP
		*getSprite()
		ƏB́Aݕ\Ăi\jXvCg
		擾̂łB

		setMySpriteƂAsetDirection(0); setMotion(0); ƂɂȂ
	*/


	///	XvCg̐ݒ/擾
	/**
		:setDirectionł́A̕ύXꍇ̓Aj[VJE^
		ZbgȂB̕ύXꍇ́AAj[VJE^
		0ɂB
	*/
	void	setDirection(int nDirection);
	int		getDirection() const { return m_nDirection; }

	///@ǉItZbgʂݒ/擾il(0,0)j
	void	setOffset(int nOffsetX,int nOffsetY);
	void	getOffset(int& nOffsetX,int& nOffsetY);

	///	݂̃Aj[Vԍݒ/擾/CNg
	void	setMotion(int n) { m_nAnimation=n; }
	int		getMotion() const { return m_nAnimation; }
	void	incMotion();
	///	Aj[VI[ɂ܂ŒB?
	bool	isEnd() const
	{ return (int)const_cast<CSprite*>(this)->getDirectionalSprite()->size()
		== m_nAnimation; }

	///	XvCg̕\Wݒ肷
	void	setPos(int x,int y) { m_nX = x; m_nY = y; }
	void	getPos(int&x,int&y) const { x=m_nX; y=m_nY; }

	///	̐ݒ(̏gg܂\Ȃ)
	void	setHeight(int nHeight) { m_nHeight=nHeight; }
	int		getHeight() const { return m_nHeight; }

	///	XvCgLɂ/Lǂ̏Ԃ擾
	///	(̏gg܂\Ȃ)
	void	enable(bool bEnable) { m_bVisible = bEnable; }
	bool	isEnable() const { return m_bVisible; }

	///	XvCg̃vCIeBݒ肷
	///	(̏gg܂\Ȃ)
	void	setPriority(int nPriority) { m_nPriority = nPriority; }
	int		getPriority() const { return m_nPriority;}

	CSprite();
	virtual ~CSprite();

protected:
	smart_ptr<spritevectorofvector>		m_vSprtieVector;
	int		m_nDirection;		//	Ă
	int		m_nAnimation;		//	Aj[VJE^
	/**
		m_vSprtieVector[m_nDirection][m_nAnimation]
		ʂɕ`悷ƍlB

		m_nAnimation̓Aj[VJE^Ȃ̂
		t[IɉZ

		m_nDirectiońALN^̌ύXB
		iƂɈÃAj[V`Ăƍl)
	*/

	//	ȉ̃o̓fBtHg0
	int		m_nX,m_nY;			//	\ʒu
	//	ȉ͎gȂΎgȂėǂ
	int		m_nOx,m_nOy;		//	ItZbgW
	int		m_nHeight;			//	(L̃x[XCZô)
	bool	m_bVisible;			//	\E\
	int		m_nPriority;		//	`vCIeB
};

struct CSpriteEx : public CSprite {
/**
	`@\̃XvCgNX
	KvɉāÃNXhăo𑫂A
	CSpirteʂɔh邩ĎgĂ
*/
public:

	void	Blt(ISurface*pSurface,LPRECT lpClip=NULL);
	//	ʏ`(Aj[VJEgZ)

	void	Blt(ISurface*pSurface,int x,int y,LPRECT lpClip=NULL);
	//	Ww`(Aj[VJEgZ)

	void	BltFix(ISurface*pSurface,LPRECT lpClip=NULL);
	//	Aj[VJEg͉ZȂ`

	void	BltFix(ISurface*pSurface,int x,int y,LPRECT lpClip=NULL);
	//	Ww`(Aj[VJEg͉ZȂ)

	void	BltOnce(ISurface*pSurface,int x,int y,LPRECT lpClip=NULL);
	//	Aj[VJEgŌɂȂĂ炻ȏ͉ZȂ`
	//	(ȊȌꍇɂ̓Aj[VJEgZ)
};

class CSpriteChara {
///	t@CXvCg`ǂݍނ߂̃[_[
///	(yaneSDK2ndCSpriteChara݊)
public:

	///	Lp^[`t@CeLXgt@Cǂݍ/
	LRESULT	Load(const string& strFileName);
	void	Release();

	/**
		LoadƂɐT[tF[X
		CPlaneɐݒ肵Ăfactoryp
	*/

	///	Loadœǂݍ񂾃XvCg`擾
	///	(œ̂CSprite::setMySpriteɓnƗǂ)
	smart_ptr<CSprite::spritevectorofvector> getMySprite()
		{ return m_vSpriteVector; }
	void	setMySprite(const smart_ptr<CSprite::spritevectorofvector>& v)
		{ m_vSpriteVector = v; }

protected:

	///	Loadœǂݍ񂾂Ƃ̃T[tF[X
	smart_vector_ptr<ISurface>	m_apSurface;

	///	WJXvCg
	smart_ptr<CSprite::spritevectorofvector> m_vSpriteVector;
};

}} // end of namespace

#endif
