//
//	yaneTextFastPlane.h :
//
#ifdef USE_FastDraw

#ifndef __yaneTextFastPlane_h__
#define __yaneTextFastPlane_h__


#include "yaneFont.h"
#include "yaneFastPlane.h"

namespace yaneuraoGameSDK3rd {
namespace Draw {

class CTextFastPlane : public CFastPlane {
public:

	CFont*	GetFont() { return &m_Font; }
	void	SetTextPos(int x,int y){ m_nTextX=x; m_nTextY=y; }
	LRESULT	UpdateText();
	LRESULT	UpdateTextA();	//	A`Fo[W
										//	l悤ɂȂ̂ŕ`BlendBltFastAlphaōsȂ
	LRESULT	UpdateTextAA(); //	ׂȃA`Fo[W
										//	UpdateTextAA肸ԂxOOGG
	void	SetVertical(bool bVertical = true) { m_bVertical = bVertical; }
	bool	IsVertical() { return m_bVertical; }
	CTextFastPlane(CFastDraw* pFastDraw=NULL);
	virtual ~CTextFastPlane() {};	//	plane holder

protected:
	CFont		m_Font;				//	ŕ`
	int			m_nTextX,m_nTextY;	//	eLXg`ʒu
	bool		m_bVertical;		//@cǂ

	virtual		LRESULT OnDraw();	//	XgAp֐
	int			m_nUpdateType;		//	XgAƂ̎
									//	0:XgAȂ 1:UpdateText 2:UpdateTextA 3:UpdateTextAA
};

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd

#endif	//	__yaneTextFastPlane_h__ 

#endif // USE_FastDraw
