// DirectInput Wrapper

#include "stdafx.h"
#include "yaneKeyInput.h"
#include "../Auxiliary/yaneCOMBase.h"
#include "../AppFrame/yaneAppManager.h"
#include "../AppFrame/yaneAppInitializer.h"

// #include "../Window/yaneDebugWindow.h"

namespace yaneuraoGameSDK3rd {
namespace Input {

CKeyInput::CKeyInput(bool bBackGround){

	m_lpDIKeyDev = NULL;
	m_nStatus = GetDirectInput()->GetStatus();
	if (m_nStatus>=3) return ; // sĂɂ

	LPDIRECTINPUT lpDInput = GetDirectInput()->Get();

	//L[{[hfoCX̍쐬
	if (lpDInput->CreateDevice(GUID_SysKeyboard
			,&m_lpDIKeyDev,NULL)!=DI_OK){
		Err.Out("CKeyInput::CKeyInputDirectInput̏CreateDeviceɎs");
		m_nStatus = 6;
		return ; // [...
	}
	//	L[{[htH[}bg̐ݒ
	if(GetDevice()->SetDataFormat(&c_dfDIKeyboard)!=DI_OK){
		Err.Out("CKeyInput::CKeyInputDirectInput̏SetDataFormatɎs");
		m_nStatus = 7;
		return ;
	}
	// WindowNTœ삳ɂ́ÁA
	// DISCL_FOREGROUND | DISCL_NONEXCLUSIVEłȂĂ͂ȂB
	
//			CDbg().Out((int)CAppManager::GetHWnd());
	if (bBackGround){
		//	obNOEhł̓͂
		if (GetDevice()->SetCooperativeLevel( CAppManager::GetHWnd(),
			//	obNOEh̓͂ꍇłAEBhDnh͎w肷ׂ
			DISCL_BACKGROUND| DISCL_NONEXCLUSIVE)!=DI_OK){
			Err.Out("CKeyInput::CKeyInputDirectInput̏SetCooperativeLevelɎs");
			m_nStatus = 8;
			return ;
		}
	} else {
		//	obNOEhł͕̓͂s
		if (GetDevice()->SetCooperativeLevel( CAppManager::GetHWnd(),
			DISCL_FOREGROUND | DISCL_NONEXCLUSIVE)!=DI_OK){
			Err.Out("CKeyInput::CKeyInputDirectInput̏SetCooperativeLevelɎs");
			m_nStatus = 8;
			return ;
		}
	}
	/**
		AGetHWndł͂ȂANULL(fXNgbv)ɂ΁A
		fXNgbvƊ֘At̂ŁÃEBhD
		L[tH[JXƂ͂邱Ƃo悤ɂȂB
	*/

	///	ʉ߂ƂƂ́Am_nStatus==0 or 1 or 2

	m_bDIKeyAcquire=false;	//	AhookOɐݒ肵Ȃ
	CAppManager::Hook(this);//	tbNJnB
}

// ---------------------------------------------------------------------------
CKeyInput::~CKeyInput(){
	if (m_nStatus <= 2){
		CAppManager::Unhook(this);			//	tbNB
	}

	// lĂfoCX̉
	if(GetDevice()!=NULL){
		if (m_bDIKeyAcquire)
			GetDevice()->Unacquire();
		GetDevice()->Release();
	}

	//	COM̉́ACCOMObjectɂĂ͂DD
}

// ---------------------------------------------------------------------------

LRESULT CKeyInput::Input(){
	if (m_nStatus >= 3) {
		return 1;	//	sƂDD
	}

	//	obt@flip!
	FlipKeyBuffer(m_nKeyBufNo);

	LRESULT hr;

	// AcquireĂȂ̂GetDeviceState炨Ȃ
	if (!m_bDIKeyAcquire){
		// AcquireƂ̂
		hr=m_lpDIKeyDev->Acquire();
		if (hr==DI_OK) {
			m_bDIKeyAcquire=true;
		} else {
			m_bDIKeyAcquire=false;
			// ȂƂɂ:p
			//	obt@NAĖ߂BiʊOɃtH[JXڂƂɉςȂ
			//	ɂȂ̂h߁j
			::ZeroMemory((LPVOID)&(m_byKeyBuffer[m_nKeyBufNo][0]),256);
			return 1;
		}
	}
	hr = GetDevice()->GetDeviceState(256,
			(LPVOID)&(m_byKeyBuffer[m_nKeyBufNo][0]));
	if (hr==DIERR_INPUTLOST){
	// Av؂ւuԂ͂[Ȃ̂	
		hr=GetDevice()->Acquire();
		if (hr!=DI_OK) {
			// ȂƂɂ
			m_bDIKeyAcquire = false;	//	ɂ܂lĂˁI:p
			//	obt@NAĖ߂BiʊOɃtH[JXڂƂɉςȂ
			//	ɂȂ̂h߁j
			::ZeroMemory((LPVOID)&(m_byKeyBuffer[m_nKeyBufNo][0]),256);
			return -1; // s̊
			// Err.Out("GetKeyStateŃfoCXLOSTĂ");
		}
		//	ok
		hr = GetDevice()->GetDeviceState(256,
			(LPVOID)&(m_byKeyBuffer[m_nKeyBufNo][0]));
	}
	if (hr==DI_OK) {
		return 0;
	} else {
		//	obt@NAĖ߂BiʊOɃtH[JXڂƂɉςȂ
		//	ɂȂ̂h߁j
		::ZeroMemory((LPVOID)&(m_byKeyBuffer[m_nKeyBufNo][0]),256);
		m_bDIKeyAcquire = false;	//	ɂ܂lĂˁI:p
		return 1;
	}
}

//////////////////////////////////////////////////////////////////////////////

LRESULT CKeyInput::WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){

	// ALTƂQ[ŎgŃL[bZ[Ŵ͎Ă...
	if ( WM_KEYFIRST<=uMsg && uMsg<=WM_KEYLAST ) {
//		CDbg().Out(uMsg);
//		return 1;
	}

	switch(uMsg){
	case WM_ACTIVATEAPP: {
/*	//	܂̃EBhDANeBułȂAق񂩁H
		UINT bActive = wParam;
		if(bActive) {
			//	bZ[W|vł͂ȂA[J[XbhŃXgAׂ...
			// AcquireƂ̂H
			if (!m_bDIKeyAcquire) {
				m_bDIKeyAcquire=(m_lpDIKeyDev->Acquire()==DI_OK);
			}
		}
*/
						 } break;
	}
	return 0;	//	all right,sir...
}

//////////////////////////////////////////////////////////////////////////////
//	0x80&ƂKvŁAoverrideقǂH

inline bool CKeyInput::IsKeyPress(int key) const {
	return	(m_byKeyBuffer[m_nKeyBufNo][key] & 0x80) !=0;
};

inline bool CKeyInput::IsKeyPush(int key) const {
	// ꂽuԂtrueɂꍇ
	if (!(m_byKeyBuffer[  m_nKeyBufNo][key] & 0x80)) return false;
	if (  m_byKeyBuffer[1-m_nKeyBufNo][key] & 0x80) return false;
	return true;
}

//////////////////////////////////////////////////////////////////////////////

} // end of namespace Input
} // end of namespace yaneuraoGameSDK3rd
