// yaneMIDIOutputDM.h
//
//		MIDIo͂ADirectMusicgčsȂB
//
//		DirectMusicgɂ́ADirectX6ȍ~KvȂ̂ŒӁI
//

#ifndef __yaneMIDIOutputDM_h__
#define __yaneMIDIOutputDM_h__


#include "yaneSound.h"
#include "../auxiliary/yaneFile.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

class ISoundFactory;
class CDirectMusic;
class CDirectSound;
class CMIDIOutputDM : public ISound {
public:
	CMIDIOutputDM(CDirectMusic* p);
	virtual ~CMIDIOutputDM();

	//	override from ISoundBase
	virtual LRESULT Open(const string& pFileName);
	virtual LRESULT Close();
	virtual LRESULT Play();
	virtual LRESULT Replay();
	virtual LRESULT Stop();
	virtual LRESULT Pause(){ return Stop(); }
	virtual bool IsPlay() const;
	virtual bool IsLoopPlay() const { return m_bLoopPlay; }
	virtual LRESULT SetLoopPlay(bool bLoop);
	virtual LONG	GetCurrentPos() const;
	virtual LRESULT	SetCurrentPos(LONG lPos);
	virtual LONG	GetLength() const;
	virtual LRESULT SetVolume(LONG volume); 
	virtual LONG	GetVolume() const;
	string	GetFileName() const { return m_File.GetName(); }
	virtual int	GetType() const { return 2; } // RTTIǂ

protected:
	LRESULT	InnerOpen();	//	DirectMusicI[v

	CFile	m_File;
	MUSIC_TIME m_mtPosition;	//	Pause
	int		m_bPaused;

	LRESULT	LoopPlay();	//	LoopPlayp
	bool	m_bLoopPlay;	//	LoopĐ̂H
	LONG	m_lLength;

	//	ĐZOg
	IDirectMusicSegment* m_lpDMSegment;
	//	ĐZOg̃Xe[^X
	IDirectMusicSegmentState* m_lpDMSegmentState;

	//	RXgN^œnꂽCDirectMusic̎擾
	CDirectMusic* GetDirectMusic() const { return m_pDirectMusic; }
	CDirectMusic* m_pDirectMusic;
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif
