//
//	yaneSELoader.h :
//
//		rd̓I[fBO
//

#ifndef __yaneSELoader_h__
#define __yaneSELoader_h__


#include "../Multimedia/yaneSoundLoader.h"
#include "../Math/yaneCounter.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

class CSELoader : public CSoundLoader {
public:
	enum { nSELoaderCount = 5 };
	//	fBtHgł͂Tt[ȓȂ΍ĐĊJȂ

	//	t[o߂ꍇ
	void		OnPlay();				///	t[ĂяoĂ
	void		PlayN(int nNo);			///	܂Đ(񃋁[vĐ)
	void		Play(int nNo);			///	ĂȂ΍Đ(񃋁[vĐ)
	void		PlayLN(int nNo);		///	܂Đ([vĐ)
	void		PlayL(int nNo);			///	ĂȂ΍Đ([vĐ)
	void		PlayT(int nNo,int nTimes,int nInterval=0);
										///	Đ񐔎wĐ
	void		Stop(int nNo);			///	TEh~߂
	void		Reset();				///	TEh̔rJE^̃Zbg
	bool		IsPlay(int nNo);		///	TEh͍ĐȂ̂H

	virtual smart_ptr<ISound>	GetSound(int nNo);	///	TEh̎擾
	///	 class CSoundLoader ̃ogΗǂ
	//	_BLbVNX̂̂Ⴄ̂ŃI[o[ChKv

	///	ĐLZtO
	///	(̃tOtrueȂ΁AׂĂ̍Đ̓LZ)
	bool*		GetCancelFlag()		{ return &m_bCancel; }

	void		OnPlayAndReset();
	///	݁AĐ˗̂̂IɍĐ

	///	ĐC^[o̐ݒ(fBtHgłnSELoaderCount)
	void	SetLockInterval(int nLockInterval) { m_nLockInterval = nLockInterval; }
	int		GetLockInterval() { return m_nLockInterval; }

	///	Ĉ߂CLoadCacheI[o[Ch
//	virtual LRESULT	Set(const string& filename,bool bUseID=false)
//		{ return SetHelper(filename,bUseID,CSELoaderInfo()); }
	//	CLoadCacheInfo::pObjsmart_ptr<CSELoaderInfo>𕕓̂ŕsvɂȂ

	CSELoader();
	virtual ~CSELoader();

protected:

	struct CSELoaderInfo
	{
		string strFileName;		//	ǂݍނׂt@C
		smart_ptr<ISound> obj;	//	ǂݍނׂTEh
		int		nPlay;
		//	vX̂Ƃ́Aguard timeӖ
		//		nSELoaderCountōĐāA0ɂȂ܂ŃfNg
		//	}CiXȂ΍Đ񐔂Ȃ̂OOG
		CRootCounter	nInterval;
		//	AĐ̂Ƃ̍ĐC^[o
		int		nID;
		//	ID͂ɂ߂ĂȂƃIuWFNgiteratorŉ񂵂
		//	񂷂ƂɁÃIuWFNgɑ΂郁oĂяoȂ
		CSELoaderInfo() : nPlay(0), nID(-1) {}
	};

	virtual void OnSet(const smart_obj& obj,int nID);
	virtual LRESULT	InnerLoad(const smart_obj& obj);
	//	LbVNX̂̂Ⴄ̂ŃI[o[ChKv

	bool	m_bCancel;			//	BGMLZtO
	int		m_nLockInterval;	//	̃t[ȓȂ΍ĐĊJȂ
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif
