// yaneSoundParameter.h
//		programmed by ENRA		 '02/03/28

#ifndef __yaneSoundParameter_h__
#define __yaneSoundParameter_h__


namespace yaneuraoGameSDK3rd {
namespace Multimedia {

class ISoundStreamFactory;
class CSoundParameter
/**
	O[otH[JXAOvOCNXȂǂ̎wێNX
	ύX́ÃNXLĂSĂISoundCX^Xɉe
*/
{
public:
	CSoundParameter();
	virtual ~CSoundParameter(){};

	/**
		TEhobt@AO[otH[JX̂ݒE擾
		trueɂĂ΁AtH[JX̃Xbh
		EBhD痣ĂTEh͕
		ATEhobt@𐶐ȂΔfȂ
		ftHgłfalse
	*/
	virtual void SetGlobalFocus(bool b) { m_bGlobalFocus = b; }
	virtual	bool IsGlobalFocus() const { return m_bGlobalFocus; }

	/**
		TEhobt@ApRg[@\̂ݒE擾
		ftHgłfalse
	*/
	virtual void SetPanControl(bool b) { m_bPanControl = b; }
	virtual	bool IsPanControl() const { return m_bPanControl; }

	/**
		TEhobt@AgRg[@\̂ݒE擾
		ftHgłfalse
	*/
	virtual void SetFrequencyControl(bool b) { m_bFrequencyControl = b; }
	virtual	bool IsFrequencyControl() const { return m_bFrequencyControl; }

	/**
		ISoundStreamFactoryhNX̐ݒE擾
		OvOCȂǂ̎w͂̃NXɑ΂čs
		ftHgłCSoundStreamFactory
	*/
	virtual void SetStreamFactory(const smart_ptr<ISoundStreamFactory>& p) { m_pStreamFactory = p; }
	virtual smart_ptr<ISoundStreamFactory> GetStreamFactory() const { return m_pStreamFactory; }

protected:
	// TEhobt@O[otH[JX̂
	bool	m_bGlobalFocus;
	// TEhobt@pRg[@\̂
	bool	m_bPanControl;
	// TEhobt@gRg[@\̂
	bool	m_bFrequencyControl;
	// ISoundStreamfactory
	smart_ptr<ISoundStreamFactory> m_pStreamFactory;
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif // __yaneSoundParameter_h__
