// yaneWaveSound.h
//		programmed by ENRA		 '02/03/25

#ifndef __yaneWaveSound_h__
#define __yaneWaveSound_h__


#include "yaneSound.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

class IWaveOutput;
class CWaveSound : public IWaveSound {
/**
	class CWaveStaticSound  class CWaveStreamSound 
	V[XɈ߂proxyNX

	StopATEh̃oO΍̂߂ɁA50msĂtF[hȂ
	~B(CAppIntervalTimer𗘗p)
*/
public:
	CWaveSound(IWaveOutput* p);
	virtual ~CWaveSound();

	/// Xg[Đ邩ݒE擾
	/// ݒ肵uԂɑɃCX^X̂ւs
	void	SetStreamPlay(bool b);
	bool	IsStreamPlay() { return m_bStreamPlay; }

	/// overriden from class ISound
	virtual LRESULT Open(const string& strFileName);
	virtual LRESULT Close();
	virtual LRESULT Play();
	virtual LRESULT Replay();
	virtual LRESULT Stop();
	virtual LRESULT Pause();
	virtual bool	IsPlay() const;
	virtual LRESULT	SetLoopPlay(bool bLoop);
	virtual bool	IsLoopPlay() const;
	virtual LONG	GetLength() const;
	virtual LRESULT SetCurrentPos(LONG lPos);
	virtual LONG	GetCurrentPos() const;
	virtual LRESULT SetVolume(LONG volume);
	virtual LONG	GetVolume() const;
	virtual string	GetFileName() const;
	int	GetType() const { return 5; }

	/// override from class IWaveSound
	virtual LRESULT Restore();

protected:
	smart_ptr<IWaveSound>	GetSound() const { return m_vSound; }
	smart_ptr<IWaveSound>	m_vSound;

	IWaveOutput*	GetOutput() const { return m_pOutput; }
	IWaveOutput*	m_pOutput;

	// ----	ZJ_̃oO΍̂50msV΂Ă~ ------

	//	uFadeȂStopṽtOƂ擾֐^ݒ肷֐
	bool	m_bFadeStop;
	bool	IsFadeStop() const { return m_bFadeStop; }
	void	SetFade(bool b) { m_bFadeStop = b; } // 
	
	LONG	m_lOriginalVolume;	//	FadeȌH[
	//	(FadeÃH[ɖ߂)
	void	StopFade();		//	FadeĂ̂Ȃ΁A~

	LRESULT InnerStop();
			//	Stop̎
	LRESULT InnerSetVolume(LONG lVolume);
			//	FadeɃR[obNSetVolume
	// ----------------------------------------------------------------

	bool	m_bStreamPlay;
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif // __yaneWaveSound_h__
