// enraWaveStream.h
//		programmed by ENRA		'02/03/25

#ifndef __yaneWaveStream_h__
#define __yaneWaveStream_h__


#include "yaneSoundStream.h"

namespace yaneuraoGameSDK3rd { namespace Auxiliary { class IFile;}}

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

class CWaveStream : public ISoundStream {
/**
	wav`̃TEhf[^ǂݍ class ISoundStream hNX
*/
public:
	CWaveStream();
	virtual ~CWaveStream();

	/// override from class ISoundStream
	LRESULT	Open(const char* filename);
	LRESULT	Close();
	LONG	GetLength() const;
	LRESULT	SetCurrentPos(LONG lPosition);
	LONG	GetCurrentPos() const;
	DWORD	Read(BYTE* lpDest, DWORD dwSize);
	WAVEFORMATEX* GetFormat() const;

protected:
	/// t@CpIFile𓾂
	smart_ptr<IFile>	GetFile() const { return m_vFile; }
	smart_ptr<IFile>	m_vFile;

	/// Openp̃wp֐
	/// mmioOpenAWAVEFORMATEX̐ݒAf[^TCY̎擾Ȃǂs
	LRESULT	Initialize();

	/// Pʕϊpwp֐i0xffffffff̓G[j
	LONG	ByteToMsec(DWORD dwByte) const;
	DWORD	MsecToByte(LONG lMsec) const;

	// t@CۂƃɓǂݍłȂtrue
	bool	m_bStaticOpen;
	// WAVEFORMATEX
	WAVEFORMATEX m_vWaveFormat;
	// g`f[^ւ̃t@C擪̃ItZbg
	DWORD	m_dwDataOffset;
	// g`f[^ւ̒
	DWORD	m_dwDataLength;
	// ݂̔g`f[^̈ʒu
	DWORD	m_dwReadPosition;
	HMMIO	m_hmmio;
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif // __yaneWaveStream_h__
