// yaneFPSTimer.h
//
//	mʂȂEFCg|
//
//	SetFPSFPSZbgāAƂ́A`OɂłAWait()邾ŗǂB
//

#ifndef __yaneFPSTimer_h__
#define __yaneFPSTimer_h__


#include "yaneTimer.h"

namespace yaneuraoGameSDK3rd {
namespace Timer {

class IFPSTimer {
public:
	virtual void SetFPS(DWORD fps)=0;
	virtual DWORD GetFPS()=0;
	virtual DWORD GetRealFPS()=0;
	virtual DWORD GetCPUPower()=0;
	virtual DWORD GetSkipFrame() const =0;
	virtual void ResetTimer()=0;
	virtual void WaitFrame()=0;
	virtual bool ToBeSkip() const=0;
	virtual void ResetElapseTimeCounter()=0;
	virtual DWORD GetElapseTimeCounter()=0;
	virtual void ResetCallCounter()=0;
	virtual DWORD GetCallCounter()=0;

	virtual ~IFPSTimer(){}
};

class CFPSTimer : public IFPSTimer {
/**
	ԂIɑ҂߂̃^C}[B
	t[[gibԂ̕`文jUOeoriFrames Par Secondj
	鎞ȂǂɎgB

*/
public:
	virtual void SetFPS(DWORD fps);
	/**
		FPS̐ݒiCjVCY˂j
		fBtHgł͂UOeorB
	*/

	virtual DWORD GetFPS();
	///	 FPS̎擾

	virtual DWORD GetRealFPS();
	/**
		 FPS̎擾ilj
		1bԂɉWaitFrameĂяoA
		O32̌ĂяoԂ̕ςZoB
	*/

	virtual DWORD GetCPUPower();
	/**
		 CPUғ̎擾ilj
		bot̉ғɍ킹āA0`100̊Ԃ̒lԂB
		́AWaitFrameSleepԂZoꂽ̂łāA
		܂ŎQllłB
	*/

	virtual DWORD GetSkipFrame() const;
	/**
	SetFPSꂽl܂ł̕`ɁAToBeSkiptrueɂȂĂt[ԂB
	AŌt[Ƃ́AWaitFraměĂяoƂ
	Pt[ƌvZB
	*/

	virtual void ResetTimer();
	/**
		҂Ԃ̒[̃ZbgiʁAgKv͂Ȃj
		WaitFrameł́AOWaitFrameĂяoԂȂ҂Ԃ
		ZôɎgiSetFPSŐݒ肵lɋ߂Â悤Ƃ邽߁AOA
		sĂԂ̑҂Ԃ猸炷ĵŁAǑĂяoԂ
		ݎɂ邱ƂɂāȂ҂Ԃւ̏Ĉ̊֐B
		ʏAgƂ͖B
	*/

	virtual void WaitFrame();
	/**
		Pt[̎Ԃ܂ő҂
	@	C[v̂Ȃł́A`揈sȂƁA
		WaitFrameĂяo΁ASetFPSŐݒ肵
		t[[gɎIɒB
	*/

	virtual bool ToBeSkip() const;
	/**	
		̃t[XLbvׂH
	AꂪtrueԂĂȂ΁Ãt[̕`܂邲
	XLbvĂ܂΁iAL̈ړ̌vZ͍sȂjA
	bԂ̂eor͒x}VłƉ肵ăvO邱ƂoB
	ÂƂWaitFrame͌ĂяoƁB
	ڂ́A˂炨̃z[y[W
		http://www.sun-inet.or.jp/~yaneurao/
	̓V˃Q[vO}{MvXQP͂QƂ̂ƁB

	܂At[XLbv邩ǂ́AWaitFrame̒iKŊm肷B
	̂߁AWaitFrameĂяo܂ŁAToBeSkip͓^UlԂB
	*/


	/**
		WaitFrameŏԂ݌vŃJEgĂB
		̃JE^̂ZbgƎ擾̂̊֐łB
	*/
	virtual void ResetElapseTimeCounter();
	///		Ԃ̃Zbg
	virtual DWORD GetElapseTimeCounter();
	///		Ԃ̎擾

	/**
		WaitFrameĂяoƂɓIȌĂяoJE^
		CNgB̃JE^ZbĝƎ擾̂
		̊֐łB
	*/
	virtual void ResetCallCounter();
	///		ďoJE^̃Zbg
	virtual DWORD GetCallCounter();
	///		ďoJE^̎擾

	CFPSTimer();
	virtual ~CFPSTimer();

protected:
	DWORD m_dwFPS;		  //  FPS(fBtHg60)
	DWORD m_dwFPSWait;	  // =1000*0x10000/FPS; // 60FPSɊÂEFCg
	DWORD m_dwLastDraw;	  // O̕`掞
	DWORD m_dwFPSWaitTT;  // O񔭐[Ԃ̕ێ̂
	DWORD m_dwElapsedTime;	  // O񃊃ZbgĂElapseꂽ
	int	  m_nUnuseSleep;	  // Wait֐Sleep𗘗p邩
	DWORD m_dwDrawTime[32];	   // FPSp̕`掞ԌvZp
	DWORD m_dwElapseTime[32];  // CPU Powerp
	DWORD m_nDrawCount;		   // i32̌ďoԂ̕ςFPS߂j
	DWORD m_dwCallCount;	// WaitFrameĂяoꂽ

	bool	m_bFrameSkip;		 //	̃t[̓XLbv̂H
	DWORD	m_dwFrameSkipCounter; // @t[XLbvJE^
	DWORD	m_dwFrameSkipCounterN; // ṽt[XLbvJE^

	CTimer	m_vTimer;
	CTimer* GetTimer() { return &m_vTimer; }
};

} // end of namespace Timer
} // end of namespace yaneuraoGameSDK3rd

#endif
