//	yaneDebugWindow.h :
//		programmed by yaneurao	'00/02/25

#ifndef __yaneDebugWindow_h__
#define __yaneDebugWindow_h__


#include "../AppFrame/yaneAppBase.h"
#include "../Auxiliary/yaneStream.h"

namespace yaneuraoGameSDK3rd {
namespace Window {

class CDebugWindow : public CAppBase , public ITextOutputStream {
/**
	G[Ȍo͂̂߂̃EBhDNXB
	class CAppBase hAvNXȂ̂ŁARun()֐ĂяoA
	𐶐ĂgƁB܂ACAppBasehĂ̂ŁA
	class CAppFrame MainThread̂ȂŎgƁB

	fobÔƂ̕ϐ̃EIb`ɎgȂ΁A
	class CDbg ̂قgقfR֗B

	gpF
	CDebugWindow dbg;
	dbg.Run();
@	dbg.Out("This may be a bug...");
*/
public:
	virtual void	Clear();						//	NA
	virtual void __cdecl Out(LPSTR fmt, ... );		//	\
	virtual void	Out(int);						//	\
	virtual void	Out(const string&);
	virtual void	Out(LONG*);		//	ψo[W
protected:
	virtual LRESULT OnPreCreate(CWindowOption&);		//	overriden from CAppBase
};

//	fobOEBhD̃[JCY
class CDbg : public ITextOutputStream {
/**
	CDebugWindowA[JCYo[WB
	CDebugWindowƓo֐B
	̃NX̏ꍇARun()͕svŁAOutƂɕKvƂ
	IɃfobOEBhDJBfobOprɂ́Aꂪ֗B

	
	CDbg().Out("x = %d",x);
*/
public:
	//	֐C^[tF[X͓BׂCDebugWindowɈϏĂ܂
	virtual void	Clear()					{
		CCriticalLock guard(GetCriticalSection());
		CheckValid(); GetWindow()->Clear();
	}

	virtual void __cdecl Out(LPSTR fmt, ... );
	virtual void	Out(int i);
	virtual void	Out(const string&s);
	virtual void	Out(LONG*lpl);
	
	static void	SelectWindow(int nDebugWindowNo){
		//if (0<=nDebugWindowNo && nDebugWindowNo<10) m_nTarget = nDebugWindowNo;
		SetTargetWindowNo(nDebugWindowNo);
	}
	/**
		fobOEBhD̃io[w肷B0`9Bdefaultł0B
		ύX邱ƂŁAo͐ύXłB
		ĩfobOEBhD쐬łBj
	*/
	static int	GetTargetWindowNo() {
		CCriticalLock guard(GetCriticalSection());
		return m_nTarget;
	}
	static void	SetTargetWindowNo(int nDebugWindowNo) {
		CCriticalLock guard(GetCriticalSection());
		if (0<=nDebugWindowNo && nDebugWindowNo<10) m_nTarget = nDebugWindowNo;
	}

protected:
	void	CheckValid();
	CDebugWindow* GetWindow(){ return m_lpDebugWindow[m_nTarget]; }

	static	CDebugWindow* m_lpDebugWindow[10];
		//	ő10i΁j
	static	int m_nTarget;	//	ݑΏۂƂĂfobOEBhD

	static	CCriticalSection	m_cs;
	static	CCriticalSection*	GetCriticalSection() { return &m_cs;}
	//	Ȃ₩₷Ƃ́Arp

	//	ACAppManagerIɃR[obNĂ炤
	static void		Release(int nTarget);
};

} // end of namespace Window
} // end of namespace yaneuraoGameSDK3rd

#endif
