// yaneWinHook.h
//	WindowMessageHooker
//	  WindowbZ[WtbN邱ƂWindow̃TuNXAVXg
//	  (c) yaneurao '99/06/23
//
//		programmed by yaneurao(M.Isozaki)	'99/06/21
//		reprogrammed by yaneurao			'00/02/25

#ifndef __yaneWinHook_h__
#define __yaneWinHook_h__


#include "../Thread/yaneCriticalSection.h"

namespace yaneuraoGameSDK3rd {
namespace Window {

class IWinHook {
/**
	EBhDbZ[WtbN̂ɗp܂B
	bZ[WtbNNX́ÃNXhāÅ֐

	virtual LRESULT WndProc(HWND,UINT,WPARAM,LPARAM) = 0; 

	I[o[Ch܂B̊֐̓bZ[WꍇA
	0Ԃ悤ɃR[fBO܂B

	class CWinHookList QƂĂB
*/
public:
	virtual	LRESULT	WndProc(HWND,UINT,WPARAM,LPARAM) = 0;
	virtual ~IWinHook(){}
};

class IWinHookList {
public:
	virtual void	Add(IWinHook*)=0;		//	gtbNɉ
	virtual void	Del(IWinHook*)=0;		//	gtbNO
	virtual void	Clear()=0;				//	ׂĂNA

	//	bZ[WDispatcher
	virtual LRESULT Dispatch(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam,WNDPROC pWndProc=NULL)=0;
	virtual LRESULT DispatchDlg(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam,WNDPROC pWndProc=NULL)=0;
};

class CWinHookList : public IWinHookList {
/**
	EBhDbZ[WtbN̂ɗp܂B
	CWinHookhꂽNX̃|C^ێAǗĂ܂B

	P̃EBhDNXɑ΂ĂPCWinHookListΉ܂B
	}`XbhΉłB

	bZ[W̔zMɂ́AWindowNXAĂяo܂B
	ƁA̕ێĂCWinHookWndProcɈϏĂ܂B
	Ϗ́AKAddԂłAWndProc0Ԃ̂ɏo܂
	WndProcĂяoÂ܂BǗĂ邷ׂĂCWinHookWndProc
	Ăяoꍇ́AfBtHg̏֐Ƃ::DefWindowProc
	Ăяo܂B

	CAppBase̓bZ[W|v͕ʃXbhȂ̂ŁAHookJn̏uԂA
	WMbZ[Wł̂ŁAIĂȂ^C~O
	WMbZ[WȂ悤ɏ\ӂĂB

	bZ[W|vʃXbhōsȂꍇAHookJn̏uԂA
	WMbZ[Wł̂ŁAIĂȂ^C~O
	WMbZ[WȂ悤ɏ\ӂĂB

*/
public:
	virtual void	Add(IWinHook*);		//	gtbNɉ
	virtual void	Del(IWinHook*);		//	gtbNO
	virtual void	Clear();			//	ׂĂNA

	///	bZ[WDispatcher
	///	҂́ADialogpŁAŌDefWindowProcĂяoȂ
	virtual LRESULT Dispatch(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam,WNDPROC pWndProc=NULL);
	virtual LRESULT DispatchDlg(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam,WNDPROC pWndProc=NULL);

protected:
	typedef list<IWinHook*> hooklist;
	hooklist			m_HookPtrList;	//	tbNXg
	CCriticalSection	m_oCriticalSection;
	CCriticalSection*	GetCriticalSection() { return& m_oCriticalSection;}
};

class CMessagePooler : public IWinHook {
/**
		{^͉񂪗̂ŁÃbZ[W
		hook`ŏ擾

		)
		{^Ȃ

			uMsg = WM_COMMAND , wParam = nEditControl
		Â悤
		OuMsgwParamyAɂăbZ[Wdispatcher
		o^ĂAƂŉ̓L[̃f[^𒲂ׂƗǂ

	sȂ߂̃wpNXACMessagePoolerłB
	uMsgwParam̑΂o^Ă΁ÃbZ[W
	PoolĂĂB(ƂŒׂĎoƂo)

	//	bZ[ŴÂ̂͏㏑(^^;
*/
public:
	struct CInfo {
	bool	isPool() const { return bPool; }
	/// bZ[WpoolĂ邩?

	void	reset() { bPool = false; }
	///	bZ[Wreset(bZ[WpoolĂȂԂɂ)

	void	init() {
		bPool = false;
		lParam=uMsg=wParam=0;
		bWparamEnable=bLparamEnable = false;
	}
	///	̍\̂(hookׂbZ[W)

	bool	isEmpty() const {
		return uMsg==0 &&
			(!bWparamEnable||wParam==0) &&
			(!bLparamEnable||lParam==0);
	}
	///	̍\̂ɂ͂܂hookׂbZ[Wo^ĂȂ?

	WPARAM	getWParam() { return wParam; }
	void	setWParam(WPARAM w) { wParam = w;}
	///	poolĂ郁bZ[WwParamݒ/擾

	LPARAM	getLParam() { return lParam; }
	void	setLParam(LPARAM l) { lParam = l;}
	///	poolĂ郁bZ[WlParamݒ/擾

	void	pool(WPARAM w,LPARAM l){
		if(!bWparamEnable) wParam=w;
		if(!bLparamEnable) lParam=l;
		bPool = true;
	}
	///	bWparamEnablefalseȂ΁AwParamw荞
	/// bLparamEnablefalseȂ΁AlParaml荞
	///	bPooltrueɂȂ̂isPooltrueԂ悤ɂȂ
	
	void	setMsg(UINT u,WPARAM w,bool bWEnable,LPARAM l,bool bLEnable)
	{ uMsg=w; wParam = w; lParam=l; bWparamEnable=bWEnable; bLparamEnable=bLEnable; }
	///	pool郁bZ[Wo^
	/**
		WEnabletrueƁAo^WPARAMisMsgŔrƂɔrΏۂƂ̈Ӗ
		LEnabletrueƁAo^LPARAMisMsgŔrƂɔrΏۂƂ̈Ӗ
	*/

	bool	isMsg(UINT u,WPARAM w,LPARAM l)
	{ return uMsg==w && (!bWparamEnable || wParam== w) && (!bLparamEnable || lParam== l);}
	///	poolׂbZ[Wƈvtrue

	CInfo():bPool(false),lParam(0),uMsg(0),wParam(0),bWparamEnable(false),bLparamEnable(false) {}

	protected:
	UINT	uMsg;	//	
	WPARAM wParam;	//	uMsg,wParam̑΂pool
	LPARAM lParam;
	bool bPool;
	bool bWparamEnable;	//	vɁAWPARAM͓̂H
	bool bLparamEnable;	//	vɁALPARAM͓̂H
	};

	int		SetPoolData(UINT uMsg,WPARAM wParam,bool bWEnable,
		LPARAM lParam,bool bLEnable);
	/**
		߂l͎ʎqBGetPool̈Ƃēnď(CInfo)擾
		CInfóAuMsg,wParam̑΂ƁAisPool()trueɂB
		ɂ̂ƂlParamۑB(CInfo͂Ƃ炫bZ[Wŏ㏑)
	*/

	void	ClearPoolData(UINT uMsg,WPARAM wParam,LPARAM lParam);
	/**
		Poolf[^̂ȂAuMsg,wParam,lParamŎw肳ꂽ̂폜
		̎ʎqɂ͉e͂Ȃ
		SetPoolDataŐݒ肷ƂɁAbWEnablefalseɂĂwParam
		rΏۂɂ͂ȂȂB(nĂǂ)
		SetPoolDataŐݒ肷ƂɁAbLEnablefalseɂĂlParam
		rΏۂɂ͂ȂȂB(nĂǂ)
	*/

	CInfo*	GetInfo(int nID) { return& m_aInfo[nID]; }
	/**
		SetPoolData̖߂lIDƂĎw肵āȀ擾
	*/

protected:
	// override from CWinHook
	virtual LRESULT WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
	vector<CInfo> m_aInfo;
};

} // end of namespace Window
} // end of namespace yaneuraoGameSDK3rd

#endif
