/*
	proxy_ptr	: a pointer treating proxy object
		reprogrammed & desinged by yaneurao(M.Isozaki) '02/03/07
*/

#ifndef __YTLProxyPtr_h__
#define __YTLProxyPtr_h__

namespace yaneuraoGameSDK3rd {
namespace YTL {

template<class T> class proxy_ptr {
/**
	̃|C^́A
	KvɔꂽƂɎn߂objectnew悤ȃ|C^

	v܂ŐۗB㗝IuWFNg(virtual proxy)

	񃍁[Jstaticproxy_ptrOsingletonIɎgƂɂ
	̖肪̂ŁA
	class singleton ̂قgĂB
*/
public:
	proxy_ptr() : m_lpObj(NULL) {}

	///	|C^̂ӂ邽߂̎d|
	T& operator*() { return *get(); }
	T* operator->() { return get();	}
	T* get() { CheckInstance(); return m_lpObj; }

	///	IuWFNgNullǂ؂
	bool	isNull() const { return m_lpObj == NULL; }

	///	IuWFNgIɉ̂
	///	ifXgN^łĂj
	void Release() {
		if (m_lpObj!=NULL) {
			delete m_lpObj;
			m_lpObj = NULL;
		}
	}

	void CheckInstance(){
		if (m_lpObj==NULL) m_lpObj = new T;
	}
	/**
		CX^X݂̂̃`FbNsȂA
		݂ȂΐB{AIɍsȂKv͖A
		̃IuWFNĝɏ̎Ԃ̂A
		A^Cɂ̏sȂĂ͍Ƃɂ́A
		iKvȂ̂킩Ă΁jOɐsȂĂ
		ƂŁAłB
	*/

	~proxy_ptr() { Release(); }
protected:

	T*	m_lpObj;
};

} // end of namespace YTL
} // end of namespace yaneuraoGameSDK3rd

#endif
