/*
	ref_deleter	: QƃJE^t̎q
		programmed & desinged by yaneurao(M.Isozaki) '02/03/03
*/

#ifndef __YTLRefDeleter_h__
#define __YTLRefDeleter_h__

namespace yaneuraoGameSDK3rd {
namespace YTL {

class ref_object {
/**
	QƃJEgǗA
	Cӂ̗vfdelete邽߂̊IuWFNg

	Ǝ̉̏Ȃ΁A
	Ƃref_objecthNXȉ̂悤ɗpӂB

class my_ref_object : public ref_object {
public:
	my_ref_object(CSound* p,const smart_ptr<function_callback>&func)
		: m_p(p),m_func(func) {}
	virtual void	delete_instance() {
		delete m_p;
		m_func->run();
	}
private:
	CSound* m_p;
	smart_ptr<function_callback_v> m_func;
	//	ėpR[obNev[g
};

*/
public:
	virtual void	delete_instance()=0;
	///	ێĂIuWFNgdeleteBhNXŒ`

	//	QƃJE^̑
	void	inc_ref(){ m_nRef++; }
	bool	dec_ref(){ m_nRef--;
		//	QƃJE^0ɂȂƂɃIuWFNg̏L
		//	IdeleteB̂Ƃɂ̊֐̕ԂltrueɂȂ
		if (m_nRef == 0) {
			if (m_bOwner) delete_instance();
			return true;
		}
		return false;
	}
	///	QƃJE^̐ݒ^擾
	void	set_ref(int n) { m_nRef = n; }
	int		get_ref() const { return m_nRef; }

	///	I[i[̐ݒ^擾
	void	set_owner(bool b) { m_bOwner = b; }
	bool	get_owner() const { return m_bOwner; }

	///	IuWFNgTCY̐ݒ^擾
	void	set_obj_size(int n) { m_nObjSize = n; }
	int		get_obj_size() const { return m_nObjSize; }

	///	zIuWFNg̍ő吔̐ݒ^擾
	void	set_size(int n) { m_nMaxSize = n;}
	int		get_size() const { return m_nMaxSize; }

	virtual ~ref_object() {}	//	place holder

protected:
	//	Ȃ炸ȉ̕ϐANZbTʂďĎgƁI

	int		m_nRef;		//	QƃJEg
	bool	m_bOwner;	//	I[i[
	int		m_nObjSize;	//	IuWFNgЂƂ̃TCY
	int		m_nMaxSize;	//	zIuWFNg̍ő
};

//	zIuWFNgdelete邽߂̃ev[g
template<class T>
class nonarray_ref_object : public ref_object {
public:
	nonarray_ref_object(T* p) : m_p(p) {}
	virtual void	delete_instance() {
		delete m_p;
	}
private:
	T* m_p;	//	폜ׂAhXێĂ
};

//	Cӂ̔zdelete邽߂̃ev[g
template<class T>
class array_ref_object : public ref_object {
public:
	array_ref_object(T* pa) : m_pa(pa) {}
	virtual void	delete_instance() {
		delete [] m_pa;
	}
private:
	T* m_pa;	//	폜ׂAhXێĂ
};

/*	//	Ȃ̂ĂdȂ̂H
//	deallocatorfunctorŎw肷邽߂̃ev[g
template<class T>
class deallocator_ref_object : public ref_object {
public:
	deallocator_ref_object(T t_) : t(t_) {}
	virtual void	delete_instance() {
		t();
	}
private:
	T	t;
};
*/

/*	//	ǂownerΉȂ̂ł̃NX͕sv
//	Ȃref_object
class null_ref_object : public ref_object{
public:
	virtual void	delete_instance() {}
	//	Ȃ
};
*/

} // end of namespace YTL
} // end of namespace yaneuraoGameSDK3rd

#endif
