#include "stdafx.h"
#include "index.h"
#include "SoundManagerfY.h"

//SẺʂݒ
void SoundManagerfY::_SetSEVolume(long Volume){
	for(map<string, CSound>::iterator it=m_SE.begin();it!=m_SE.end();it++){
		it->second->SetVolume(Volume==0 ? -10000 : static_cast<long>((10*log10(static_cast<double>(Volume)/10000))*100));
	}
}
//SEĐ
bool SoundManagerfY::_PlaySE(const char* FileName){
	return(m_SE.find(FileName)->second->Play()==0);
}
//SE~
bool SoundManagerfY::_StopSE(const char* FileName){
	return(m_SE.find(FileName)->second->Stop()==0);
}
//SEɓǂݍ
bool SoundManagerfY::_LoadSE(const char* FileName){
	m_SE.insert(pair<string, CSound>(FileName, CSound()));
	if(m_SE.find(FileName)->second.Load(FileName)==0){
		return(true);
	}
	else{
		m_SE.erase(m_SE.find(FileName));
		return(false);
	}
}
//SE
bool SoundManagerfY::_UnloadSE(const char* FileName){
	if(m_SE.find(FileName)->second->Close()==0){
		m_SE.erase(m_SE.find(FileName));
		return(true);
	}
	else{
		return(false);
	}
}
//SEĐmF
bool SoundManagerfY::_IsPlayingSE(const char* FileName) const{
	return(m_SE.find(FileName)->second->IsPlay());
}
//BGM̉ʂݒ
void SoundManagerfY::_SetBGMVolume(long Volume){
	if(!m_BGM.isNull()){
		m_BGM->SetVolume(Volume==0 ? -10000 : static_cast<long>((10*log10(static_cast<double>(Volume)/10000))*100));
	}
}
//BGMĐ
bool SoundManagerfY::_PlayBGM(bool IsOnce){
	if(!m_BGM.isNull()){
		m_BGM->SetLoopPlay(!IsOnce);
		return(m_BGM->Play()==0);
	}
	return(false);
}
//BGM~
bool SoundManagerfY::_StopBGM(){
	if(!m_BGM.isNull()){
		return(m_BGM->Stop()==0);
	}
	return(false);
}
//BGMɓǂݍ
bool SoundManagerfY::_LoadBGM(const char* FileName){
	return(m_BGM.Load(FileName)==0);
}
//BGM
bool SoundManagerfY::_UnloadBGM(){
	if(!m_BGM.isNull()){
		return(m_BGM->Close()==0);
	}
	return(true);
}
//BGMĐmF
bool SoundManagerfY::_IsPlayingBGM() const{
	if(!m_BGM.isNull()){
		return(m_BGM->IsPlay());
	}
	return(false);
}
//̉ʂݒ
void SoundManagerfY::_SetVoiceVolume(long Volume){
	for(map<string, CSound>::iterator it=m_Voice.begin();it!=m_Voice.end();it++){
		it->second->SetVolume(Volume==0 ? -10000 : static_cast<long>((10*log10(static_cast<double>(Volume)/10000))*100));
	}
}
//Đ
bool SoundManagerfY::_PlayVoice(const char* FileName){
	return(m_Voice.find(FileName)->second->Play()==0);
}
//~
bool SoundManagerfY::_StopVoice(const char* FileName){
	return(m_Voice.find(FileName)->second->Stop()==0);
}
//ɓǂݍ
bool SoundManagerfY::_LoadVoice(const char* FileName){
	m_Voice.insert(pair<string, CSound>(FileName, CSound()));
	if(m_Voice.find(FileName)->second.Load(FileName)==0){
		return(true);
	}
	else{
		m_Voice.erase(m_Voice.find(FileName));
		return(false);
	}
}
//
bool SoundManagerfY::_UnloadVoice(const char* FileName){
	if(m_Voice.find(FileName)->second->Close()==0){
		m_Voice.erase(m_Voice.find(FileName));
		return(true);
	}
	else{
		return(false);
	}
}
//ĐmF
bool SoundManagerfY::_IsPlayingVoice(const char* FileName) const{
	return(m_Voice.find(FileName)->second->IsPlay());
}