#include "stdafx.h"
#include "yaneAllocator.h"

namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

//	overridden from IMemoryAllocator
BYTE* CMemoryAllocatorPool::Alloc(int size){
	synchronized guard(cs_);

	mylist::iterator it = memory_.begin();
	while (it!=memory_.end()){
		//	擪T[`ċ󂢂ĂƂ蓖Ă
		if (!(*it).bUsed_){
			int rest = (*it).size_ - size;
			if (rest >=0) {
				//	肠ĂĂ܂
				(*it).bUsed_ = true;
				BYTE* p = (*it).start_;
				//	̃ubNAc肪܂̂ȂAĂ
				//	gp̈ƂȂ΂ȂȂ
				if (rest>0) {
					it++;
					memory_.insert(it,CMemoryTable(p+size,rest,false));
				}
				return p;
			}
		}
		it++;
	}
	//	mۂłȂ
	#ifdef USE_EXCEPTION
		throw CRuntimeException(
			"CMemoryAllocatorPool::AllocŊmۂ郁s"
		);
	#else
		return NULL; // failed
	#endif
}

void CMemoryAllocatorPool::Free(BYTE* pb){
	synchronized guard(cs_);

	mylist::iterator it = memory_.begin();
	while (it!=memory_.end()){
		if ((*it).start_==pb){
			//	ꂾB`I
			if (!(*it).bUsed_){
				//	?
				#ifdef USE_EXCEPTION
					throw CRuntimeException(
						"CMemoryAllocatorPool::FreeŃ̓d"
					);
				#endif
			}
			(*it).bUsed_ = false;
			// ̑ÕubNƌłȂ炵Ă܂
			//	1.Oɑ΂Č(ƂɌĂ̂ŁA
			//		ubN2ł邱Ƃ͍lȂĂ悢)
			if (it!=memory_.begin()){
				mylist::iterator it2 = it;
				it2--;
				//	ЂƂOgp̈悩AubN̐擪܂ŐLтĂ
				//	(fЉꂽƂz肵Ă邽߁A
				//		҂̃`FbNKv)
				if (!(*it2).bUsed_ &&
					((*it2).start_ + (*it2).size_ == (*it).start_)){
					(*it2).size_ += (*it).size_;
					memory_.erase(it);
					it = it2;
				}
			}
			//	2.ɑ΂Č
			mylist::iterator it2 = it;
			it2++;
			if (it2!=memory_.end()){
				if (!(*it2).bUsed_ &&
					((*it).start_ + (*it).size_ == (*it2).start_)){
					(*it).size_ += (*it).size_;
					memory_.erase(it2);
				}
			}
			return ; // I
		}
		it++;
	}
	//	łȂ
	#ifdef USE_EXCEPTION
		throw CRuntimeException(
			"CMemoryAllocatorPool::FreeŃɎs"
		);
	#endif
}

} // end of namespace Auxiliary
} // end of namespace yaneuraoGameSDK3rd
