#include "stdafx.h"
#include "yaneSurface.h"
#include "yaneTextDIBitmap.h"
/**
	̃NX́AyaneSDK2nd̂̂ˊэHŃRsy
*/

namespace yaneuraoGameSDK3rd {
namespace Draw {

CTextDIBitmap::CTextDIBitmap(){
	m_nTextX = 0;
	m_nTextY = 0;
	m_bVertical = false;
}

void CTextDIBitmap::SetVertical(bool bVertical){
	m_bVertical = bVertical;
}

LRESULT	CTextDIBitmap::UpdateText(){
	LRESULT lr;
	if (!IsVertical()) {	// ̏ꍇ
		lr = UpdateTextHorizontal();
	} else {				// c̏ꍇ
		//	font90K|
		GetFont()->SetVerticalFont(!GetFont()->IsVerticalFont());
		lr = UpdateTextVertical();
		GetFont()->SetVerticalFont(!GetFont()->IsVerticalFont());
	}
	return lr;
}

LRESULT	CTextDIBitmap::UpdateTextA(){	//	A`Ft`
	LRESULT lr;
	if (!IsVertical()) {	// ̏ꍇ
		lr = UpdateTextHorizontalA();
	} else {				// c̏ꍇ
		//	font90K|
		GetFont()->SetVerticalFont(!GetFont()->IsVerticalFont());
		lr = UpdateTextVerticalA();
		GetFont()->SetVerticalFont(!GetFont()->IsVerticalFont());
	}
	return lr;
}

//	̃RsyOOG
LRESULT	CTextDIBitmap::UpdateTextAA(){	//	A`Ft`
	LRESULT lr;
	if (!IsVertical()) {	// ̏ꍇ
		lr = UpdateTextHorizontalAA();
	} else {				// c̏ꍇ
		//	font90K|
		GetFont()->SetVerticalFont(!GetFont()->IsVerticalFont());
		lr = UpdateTextVerticalAA();
		GetFont()->SetVerticalFont(!GetFont()->IsVerticalFont());
	}
	return lr;
}

//////////////////////////////////////////////////////////
/*

	::GetGlyphOutlinéA
		Win9xnł́Aboldw肷Ɖ
		(ōśÂňꕔ)
		܂AServicePack𓖂ĂĂȂNT4.0ƁA
			]ƂɁAOS
		ƁAꕶϊłȂ̂ŁA
		rɃC^bN܂ĂƂ̒
		OłȂƂȂB

	ȏ𗝉ĎĝȂ΁A͂Ȃ̂ǁDD
*/
//////////////////////////////////////////////////////////
// 

inline LRESULT CTextDIBitmap::UpdateTextHorizontal(){
	int sx,sy;
	m_Font.GetSize(sx,sy);
	// m_Font̃eLXgȂv[͍Ȃ
	//	(ǂBltter`FbNĕsȃv[ȂΓ]Ȃ̂)
	if (CreateSurface(sx,sy,32)) return 1;
	// wiFœhԂ
	Clear();

	m_Font.OnDraw(GetDC(),m_nTextX,m_nTextY);
	return 0;
}



inline LRESULT CTextDIBitmap::UpdateTextHorizontalA(){	//	A`Ft`
	int sx,sy;
	m_Font.GetSize(sx,sy);
	if (CreateSurface(sx,sy,32,true)) return 1;
	//@wiFœhԂ
	//	ȂƏkT[tFXRs[ɃS~̂
	Clear();

	COLORREF rgb = m_Font.GetColor();
	COLORREF bk	 = m_Font.GetBackColor();

	m_Font.SetBackColor(CLR_INVALID);
	m_Font.SetColor(RGB(255,255,255));	//	ɂ
	int	nQuality = m_Font.GetQuality();
	m_Font.SetQuality(4);	//	A`Fŏ
	int nFontSize = m_Font.GetSize();
	int nFontHeight = m_Font.GetHeight();
	m_Font.SetSize(nFontSize<<1);	//	2{TCYŕ`
	m_Font.SetHeight(nFontHeight<<1); //@sԂ2{TCYŕ`
	//	SetSizéAsԂύXĂ܂̂ŁA
	//	SetSizeOɁAsԂ擾ĂAQ{Ȃ΂ȂȂ

	CDIBitmap d_dib;
	int sx2,sy2;
	m_Font.GetSize(sx2,sy2);
	// m_Font̃eLXgłv[D
	if ((sx2 == 0) || (sy2 == 0)) {
		sx2 = sy2 = 1;
	}
	if (d_dib.CreateSurface(sx2,sy2,32,true)) return 2;
	// wiFœhԂ
	d_dib.GetSurfaceInfo()->SetFillColor(GetSurfaceInfo()->GetFillColor());
	d_dib.Clear();
	//	d_dib.GetSurfaceInfo()->GeneralEffect(CSurfaceInfo::eSurfaceFill, NULL);
	m_Font.OnDraw(d_dib.GetDC(),m_nTextX<<1,m_nTextY<<1);	//	2{̃tHgTCYŕ`

	//	Q~Q{ɏk
	{
	  sx2>>=1; sy2>>=1;
	  if (sx2<sx) { sx = sx2; }	//@ȂHꂽv[^Q̂ق...
	  if (sy2<sy) { sy = sy2; }
	  DWORD dwColor = ((rgb & 0xff) << 16) + (rgb & 0xff00) + ((rgb & 0xff0000)>>16);	//	]u
	  ULONG lDstWidth = d_dib.GetWidth();
	  for(int y=0;y<sy;y++){
		DWORD *lpdw		= (DWORD*)(GetPtr() + 4*GetWidth() * y);
		DWORD *lpdw2a	= (DWORD*)(d_dib.GetPtr() + (4*lDstWidth * (y*2)));
		DWORD *lpdw2b	= lpdw2a + lDstWidth; // C
		//	ꂽ邳`lɎĂ
		for(int x=0;x<sx;x++){
			DWORD dwAlpha;
			dwAlpha =  ((*lpdw2a)&0xff) + ((*(lpdw2a+1))&0xff);
			dwAlpha += ((*lpdw2b)&0xff) + ((*(lpdw2b+1))&0xff);
			*lpdw = ((dwAlpha << (24-2)) & 0xff000000) + dwColor;	//	F́ArgbŎw肳ꂽF
			lpdw++; lpdw2a+=2; lpdw2b+=2;
		}
	  }
	}

	//	AOOG@Ȃ񂬂ȁ[i΁j
	m_Font.SetSize(nFontSize);
	m_Font.SetHeight(nFontHeight);
	//	Ŗ߂ȂƁẢe𐶐ƂɉR̃tHgTCYɂȂ܂OOG

	//	̉e
	if (bk!=CLR_INVALID) {
	//	e񂩁DDD炵ȂOOG
		CTextDIBitmap dib;
		*dib.GetFont() = *GetFont();	//	tHg܂邲ƃRs[Ă܂[IIOOG
		dib.GetFont()->SetColor(bk);
		dib.GetFont()->SetBackColor(CLR_INVALID);	//	CLR_INVALIDɂĂ΁A̍ċA͂QxڂŒ~
//		dib.GetFont()->SetText(m_Font.GetText());
//		dib.SetTextPos(2,2);	//	炵ĕ`I
		{
			int nOx, nOy;
			dib.GetFont()->GetShadowOffset(nOx,nOy);
			dib.SetTextPos(nOx,nOy); // 炵ĕ`I
		}
		dib.UpdateTextA();
		//	PhotoShop̃CIsxt

		int alpha;
		int beta;
		int total;
		DWORD dwRGB;

		//	dib̃TCÝATCYƉłȂmȂDD
//		int nSize = GetRect()->right*GetRect()->bottom;
//		for (int i=0;i<nSize;i++){

		//	dibɂ炽ɕ`悳ƃTCYقȂ邩mȂDD
		ULONG lSrcWidth = GetWidth();
		ULONG lDstWidth = dib.GetWidth();
		for(int y=0;y<sy;y++){
			DWORD *lpdw = (DWORD*)(GetPtr() + (4* lSrcWidth * y));
			DWORD *lpdw2 = (DWORD*)(dib.GetPtr() + (4 * lDstWidth * y));
			//	ꂽ邳`lɎĂ
			for(int x=0;x<sx;x++){
				/*
				̃ASYɂẮA˂炨̃z[y[W
				X[p[vO}[ւ̓@uCB@PhotoShop̃CASYɂāiYGAtH[}bg񏥂) 00/10/18v
				QƂ̂
				*/
				alpha = *lpdw >> 24;
				beta  = *lpdw2 >> 24;
				beta  = (255-alpha)*beta / 255;	//	GlM[cʂ̌vZ
				//	z䗦܂̂ŁAɊÂĕz
				total = alpha + beta;
				if (total != 0){	//	[̂Ƃ́ARȂėǂ
					if (beta == 0){		//]悪OȂÂ܂ܓ]
						*lpdw2 = *lpdw;
					}else{
						dwRGB = ((*lpdw & 0xff) * alpha + (*lpdw2 & 0xff) * beta) / total;
						dwRGB += (((*lpdw & 0xff00) * alpha + (*lpdw2 & 0xff00) * beta) / total) & 0xff00;
						dwRGB += (((*lpdw & 0xff0000) * alpha + (*lpdw2 & 0xff0000) * beta) / total) & 0xff0000;
						dwRGB += total << 24;	//	alphaĺAGlM[
						*lpdw = dwRGB;
					}
				}
				lpdw++; lpdw2++;
			}
		}
	}

	//	AOOG@Ȃ񂬂ȁ[Qi΁j
	m_Font.SetQuality(nQuality);
	m_Font.SetColor(rgb);
	m_Font.SetBackColor(bk);

//	*GetYGA() = true;	//	for BltNatural

	return 0;
}

//	̃RsyOOG
inline LRESULT CTextDIBitmap::UpdateTextHorizontalAA(){	//	A`Ft`
	int sx,sy;
	m_Font.GetSize(sx,sy);
	if (CreateSurface(sx,sy,32,true)) return 1;
	//@wiFœhԂ
	//	ȂƏkT[tFXRs[ɃS~̂

	//	GetSurfaceInfo()->GeneralEffect(CSurfaceInfo::eSurfaceFill, NULL);
	Clear();

	COLORREF rgb = m_Font.GetColor();
	COLORREF bk	 = m_Font.GetBackColor();

	m_Font.SetBackColor(CLR_INVALID);
	m_Font.SetColor(RGB(255,255,255));	//	ɂ
	int	nQuality = m_Font.GetQuality();
	m_Font.SetQuality(4);	//	A`Fŏ
	int nFontSize = m_Font.GetSize();
	int nFontHeight = m_Font.GetHeight();
	m_Font.SetSize(nFontSize<<2);	//	4{TCYŕ`
	m_Font.SetHeight(nFontHeight<<2); //@sԂ4{TCYŕ`

	CDIBitmap d_dib;
	int sx2,sy2;
	m_Font.GetSize(sx2,sy2);
	// m_Font̃eLXgłv[D
	if ((sx2 == 0) || (sy2 == 0)) {
		sx2 = sy2 = 1;
	}
	if (d_dib.CreateSurface(sx2,sy2,32,true)) return 2;
	// wiFœhԂ
	d_dib.GetSurfaceInfo()->SetFillColor(GetSurfaceInfo()->GetFillColor());
	//	d_dib.GetSurfaceInfo()->GeneralEffect(CSurfaceInfo::eSurfaceFill, NULL);
	d_dib.Clear();
	m_Font.OnDraw(d_dib.GetDC(),m_nTextX<<2,m_nTextY<<2);	//	4{̃tHgTCYŕ`

	//	S~S{ɏk
	{
	  sx2>>=2; sy2>>=2;
	  if (sx2<sx) { sx = sx2; }	//@ȂHꂽv[^Q̂ق...
	  if (sy2<sy) { sy = sy2; }

	  ULONG dstWidth = d_dib.GetWidth();
	  ULONG srcWidth = GetWidth();
	  DWORD dwColor = ((rgb & 0xff) << 16) + (rgb & 0xff00) + ((rgb & 0xff0000)>>16);	//	]u
	  for(int y=0;y<sy;y++){
		DWORD *lpdw = (DWORD*)(GetPtr() + (4 * srcWidth * y));
		DWORD *lpdw2a =(DWORD*)(d_dib.GetPtr() + (4*dstWidth * (y*4	 )));
		DWORD *lpdw2b = lpdw2a		   +  dstWidth; // C
		DWORD *lpdw2c = lpdw2b		   +  dstWidth; // C
		DWORD *lpdw2d = lpdw2c		   +  dstWidth; // C
		//	ꂽ邳`lɎĂ
		for(int x=0;x<sx;x++){
			DWORD dwAlpha;
			dwAlpha =	((*lpdw2a)&0xff) + ((*(lpdw2a+1))&0xff) + ((*(lpdw2a+2))&0xff) + ((*(lpdw2a+3))&0xff);
			dwAlpha +=	((*lpdw2b)&0xff) + ((*(lpdw2b+1))&0xff) + ((*(lpdw2b+2))&0xff) + ((*(lpdw2b+3))&0xff);
			dwAlpha +=	((*lpdw2c)&0xff) + ((*(lpdw2c+1))&0xff) + ((*(lpdw2c+2))&0xff) + ((*(lpdw2c+3))&0xff);
			dwAlpha +=	((*lpdw2d)&0xff) + ((*(lpdw2d+1))&0xff) + ((*(lpdw2d+2))&0xff) + ((*(lpdw2d+3))&0xff);
			*lpdw = ((dwAlpha << (24-4)) & 0xff000000) + dwColor;	//	F́ArgbŎw肳ꂽF
			lpdw++; lpdw2a+=4; lpdw2b+=4; lpdw2c+=4; lpdw2d+=4;
		}
	  }
	}

	//	AOOG@Ȃ񂬂ȁ[i΁j
	m_Font.SetSize(nFontSize);
	m_Font.SetHeight(nFontHeight);
	//	Ŗ߂ȂƁẢe𐶐ƂɉR̃tHgTCYɂȂ܂OOG

	//	̉e
	if (bk!=CLR_INVALID) {
	//	e񂩁DDD炵ȂOOG
		CTextDIBitmap dib;
		*dib.GetFont() = *GetFont();	//	tHg܂邲ƃRs[Ă܂[IIOOG
		dib.GetFont()->SetColor(bk);
		dib.GetFont()->SetBackColor(CLR_INVALID);	//	CLR_INVALIDɂĂ΁A̍ċA͂QxڂŒ~
//		dib.GetFont()->SetText(m_Font.GetText());
//		dib.SetTextPos(2,2);	//	炵ĕ`I
		{
			int nOx, nOy;
			dib.GetFont()->GetShadowOffset(nOx,nOy);
			dib.SetTextPos(nOx,nOy); // 炵ĕ`I
		}
		dib.UpdateTextAA();

		//	PhotoShop̃CIsxt
		int alpha;
		int beta;
		int total;
		DWORD dwRGB;

		//	dibɂ炽ɕ`悳ƃTCYقȂ邩mȂDD
		ULONG lSrcWidth = GetWidth();
		ULONG lDstWidth = dib.GetWidth();

		for(int y=0;y<sy;y++){
			DWORD *lpdw = (DWORD*)(GetPtr() + (4*lSrcWidth * y));
			DWORD *lpdw2 = (DWORD*)(dib.GetPtr() + (4*lDstWidth * y));
			//	ꂽ邳`lɎĂ
			for(int x=0;x<sx;x++){
				/*
				̃ASYɂẮA˂炨̃z[y[W
				X[p[vO}[ւ̓@uCB@PhotoShop̃CASYɂāiYGAtH[}bg񏥂) 00/10/18v
				QƂ̂
				*/
				alpha = *lpdw >> 24;
				beta  = *lpdw2 >> 24;
				beta  = (255-alpha)*beta / 255;	//	GlM[cʂ̌vZ
				//	z䗦܂̂ŁAɊÂĕz
				total = alpha + beta;
				if (total != 0){	//	[̂Ƃ́ARȂėǂ
					if (beta == 0){		//]悪OȂÂ܂ܓ]
						*lpdw2 = *lpdw;
					}else{
						dwRGB = ((*lpdw & 0xff) * alpha + (*lpdw2 & 0xff) * beta) / total;
						dwRGB += (((*lpdw & 0xff00) * alpha + (*lpdw2 & 0xff00) * beta) / total) & 0xff00;
						dwRGB += (((*lpdw & 0xff0000) * alpha + (*lpdw2 & 0xff0000) * beta) / total) & 0xff0000;
						dwRGB += total << 24;	//	alphaĺAGlM[
						*lpdw = dwRGB;
					}
				}
				lpdw++; lpdw2++;
			}
		}
	}

	//	AOOG@Ȃ񂬂ȁ[Qi΁j
	m_Font.SetQuality(nQuality);
	m_Font.SetColor(rgb);
	m_Font.SetBackColor(bk);

//	*GetYGA() = true;	//	for BltNatural

	return 0;
}


//////////////////////////////////////////////////////////
// c

inline LRESULT CTextDIBitmap::UpdateTextVertical(){
	int sx,sy;

	m_Font.GetSize(sx,sy);
//----------------------------ύX
	if (CreateSurface(sy,sx,32)) return 1;	// tɂȂ
	// wiFœhԂ
	//	ȂƏkT[tFXRs[ɃS~̂
	//GetSurfaceInfo()->GeneralEffect(CSurfaceInfo::eSurfaceFill, NULL);
	Clear();

	// ěcpɕύX
	int nOx, nOy;
	m_Font.GetShadowOffset(nOx, nOy);
	m_Font.SetShadowOffset(nOy, -nOx);

	// cϊpɂT[tFX쐬
	CDIBitmap d_dib2;
	if (d_dib2.CreateSurface(sx, sy,32)) return 2;
	// wiFœhԂ
	d_dib2.GetSurfaceInfo()->SetFillColor(GetSurfaceInfo()->GetFillColor());
	// d_dib2.GetSurfaceInfo()->GeneralEffect(CSurfaceInfo::eSurfaceFill, NULL);
	d_dib2.Clear();

 //	m_Font.OnDraw(GetDC(),m_nTextX,m_nTextY);
	m_Font.OnDraw(d_dib2.GetDC(),m_nTextX,m_nTextY);

	// cϊ
	{
		LONG width, height;
		GetSize(width, height);
//		ULONG lSrcWidth = GetWidth();
		ULONG lDstWidth = d_dib2.GetWidth();
		for (int y=0;y<sy;y++) {
			DWORD *lpdw = (DWORD*)(GetPtr() + 4*(width - y -1));	// ̏と͏c̉E
			DWORD *lpdw2 = (DWORD*)(d_dib2.GetPtr() + 4*(lDstWidth * y));
			for (int x=0;x<sx;x++) {
				*lpdw = *lpdw2;
				lpdw+=width;	// P
				lpdw2++;
			}
		}
	}

	// ěɖ߂
	m_Font.SetShadowOffset(nOx, nOy);
//----------------------------


//	*GetYGA() = false;	//	for BltNatural
	return 0;
}

inline LRESULT CTextDIBitmap::UpdateTextVerticalA(){	//	A`Ft`
	int sx,sy;
	m_Font.GetSize(sx,sy);
//----------------------------ύX
	if (CreateSurface(sy,sx,32,true)) return 1;	// tɂȂ
	// wiFœhԂ
	//	ȂƏkT[tFXRs[ɃS~̂
	//GetSurfaceInfo()->GeneralEffect(CSurfaceInfo::eSurfaceFill, NULL);
	Clear();
//----------------------------

	COLORREF rgb = m_Font.GetColor();
	COLORREF bk	 = m_Font.GetBackColor();

	m_Font.SetBackColor(CLR_INVALID);
	m_Font.SetColor(RGB(255,255,255));	//	ɂ
	int	nQuality = m_Font.GetQuality();
	m_Font.SetQuality(4);	//	A`Fŏ
	int nFontSize = m_Font.GetSize();
	int nFontHeight = m_Font.GetHeight();
	m_Font.SetSize(nFontSize<<1);	//	2{TCYŕ`
	m_Font.SetHeight(nFontHeight<<1); //@sԂ2{TCYŕ`
	//	SetSizéAsԂύXĂ܂̂ŁA
	//	SetSizeOɁAsԂ擾ĂAQ{Ȃ΂ȂȂ

	CDIBitmap d_dib;
	int sx2,sy2;
	m_Font.GetSize(sx2,sy2);
	// m_Font̃eLXgłv[D
	if ((sx2 == 0) || (sy2 == 0)) {
		sx2 = sy2 = 1;
	}
	if (d_dib.CreateSurface(sx2,sy2,32,true)) return 2;
	// wiFœhԂ
	d_dib.GetSurfaceInfo()->SetFillColor(GetSurfaceInfo()->GetFillColor());
	//d_dib.GetSurfaceInfo()->GeneralEffect(CSurfaceInfo::eSurfaceFill, NULL);
	d_dib.Clear();
	m_Font.OnDraw(d_dib.GetDC(),m_nTextX<<1,m_nTextY<<1);	//	2{̃tHgTCYŕ`


//----------------------------ǉ
	// ěcpɕύX
	int nOx, nOy;
	m_Font.GetShadowOffset(nOx, nOy);
	m_Font.SetShadowOffset(nOy, -nOx);

	// cϊpɂT[tFX쐬
	CDIBitmap d_dib2;
	if (d_dib2.CreateSurface(sx, sy,32,true)) return 2;
	// wiFœhԂ
	d_dib2.GetSurfaceInfo()->SetFillColor(GetSurfaceInfo()->GetFillColor());
	//d_dib2.GetSurfaceInfo()->GeneralEffect(CSurfaceInfo::eSurfaceFill, NULL);
	d_dib2.Clear();
//----------------------------


/*
	//	{̂Ƃ̓]͂ŗǂDDD
	DWORD *lpdw = GetPtr();
	DWORD dwColor = ((rgb & 0xff) << 16) + (rgb & 0xff00) + ((rgb & 0xff0000)>>16);	//	]u
	//	邳`lɎĂ
	int nSize = GetRect()->right * GetRect()->bottom;
	for (int i=0;i<nSize;i++){
		*lpdw = ((*lpdw << 8)&0xff000000) + dwColor;	//	F́ArgbŎw肳ꂽF
		lpdw++;
	}
*/

	//	Q~Q{ɏk
	{
	  sx2>>=1; sy2>>=1;
	  if (sx2<sx) { sx = sx2; }	//@ȂHꂽv[^Q̂ق...
	  if (sy2<sy) { sy = sy2; }
	  DWORD dwColor = ((rgb & 0xff) << 16) + (rgb & 0xff00) + ((rgb & 0xff0000)>>16);	//	]u

	  ULONG lDstWidth = d_dib.GetWidth();
	  ULONG lDstWidth2 = d_dib2.GetWidth();

	  for(int y=0;y<sy;y++){
//----------------------------ύX
	//	DWORD *lpdw = GetPtr() + (GetRect()->right * y);
		DWORD *lpdw = (DWORD*)(d_dib2.GetPtr() + (4*lDstWidth2 * y));	// cϊp̂̂g
//----------------------------
		DWORD *lpdw2a = (DWORD*)(d_dib.GetPtr() + 4*(lDstWidth * (y*2	 )));
		DWORD *lpdw2b = lpdw2a		   + lDstWidth; // C
		//	ꂽ邳`lɎĂ
		for(int x=0;x<sx;x++){
			DWORD dwAlpha;
			dwAlpha =  ((*lpdw2a)&0xff) + ((*(lpdw2a+1))&0xff);
			dwAlpha += ((*lpdw2b)&0xff) + ((*(lpdw2b+1))&0xff);
			*lpdw = ((dwAlpha << (24-2)) & 0xff000000) + dwColor;	//	F́ArgbŎw肳ꂽF
			lpdw++; lpdw2a+=2; lpdw2b+=2;
		}
	  }
	}

	//	AOOG@Ȃ񂬂ȁ[i΁j
	m_Font.SetSize(nFontSize);
	m_Font.SetHeight(nFontHeight);
	//	Ŗ߂ȂƁẢe𐶐ƂɉR̃tHgTCYɂȂ܂OOG

	//	̉e
	if (bk!=CLR_INVALID) {
	//	e񂩁DDD炵ȂOOG
		CTextDIBitmap dib;
		*dib.GetFont() = *GetFont();	//	tHg܂邲ƃRs[Ă܂[IIOOG
		dib.GetFont()->SetColor(bk);
		dib.GetFont()->SetBackColor(CLR_INVALID);	//	CLR_INVALIDɂĂ΁A̍ċA͂QxڂŒ~
//		dib.GetFont()->SetText(m_Font.GetText());
//		dib.SetTextPos(2,2);	//	炵ĕ`I
		{
			int nOx, nOy;
			dib.GetFont()->GetShadowOffset(nOx,nOy);
			dib.SetTextPos(nOx,nOy); // 炵ĕ`I
		}
		dib.UpdateTextA();
		//	PhotoShop̃CIsxt

		int alpha;
		int beta;
		int total;
		DWORD dwRGB;

		//	dib̃TCÝATCYƉłȂmȂDD
//		int nSize = GetRect()->right*GetRect()->bottom;
//		for (int i=0;i<nSize;i++){

		ULONG lDstWidth = dib.GetWidth();
		ULONG lDstWidth2 = d_dib2.GetWidth();

		//	dibɂ炽ɕ`悳ƃTCYقȂ邩mȂDD
		for(int y=0;y<sy;y++){
//----------------------------ύX
	//		DWORD *lpdw = GetPtr() + (GetRect()->right * y);
			DWORD *lpdw = (DWORD*)(d_dib2.GetPtr() + (4*lDstWidth2 * y));	// cϊp̂̂g
//----------------------------
			DWORD *lpdw2 = (DWORD*)(dib.GetPtr() + (4*lDstWidth * y));
			//	ꂽ邳`lɎĂ
			for(int x=0;x<sx;x++){
				/*
				̃ASYɂẮA˂炨̃z[y[W
				X[p[vO}[ւ̓@uCB@PhotoShop̃CASYɂāiYGAtH[}bg񏥂) 00/10/18v
				QƂ̂
				*/
				alpha = *lpdw >> 24;
				beta  = *lpdw2 >> 24;
				beta  = (255-alpha)*beta / 255;	//	GlM[cʂ̌vZ
				//	z䗦܂̂ŁAɊÂĕz
				total = alpha + beta;
				if (total != 0){	//	[̂Ƃ́ARȂėǂ
					if (beta == 0){		//]悪OȂÂ܂ܓ]
						*lpdw2 = *lpdw;
					}else{
						dwRGB = ((*lpdw & 0xff) * alpha + (*lpdw2 & 0xff) * beta) / total;
						dwRGB += (((*lpdw & 0xff00) * alpha + (*lpdw2 & 0xff00) * beta) / total) & 0xff00;
						dwRGB += (((*lpdw & 0xff0000) * alpha + (*lpdw2 & 0xff0000) * beta) / total) & 0xff0000;
						dwRGB += total << 24;	//	alphaĺAGlM[
						*lpdw = dwRGB;
					}
				}
				lpdw++; lpdw2++;
			}
		}
	}

	//	AOOG@Ȃ񂬂ȁ[Qi΁j
	m_Font.SetQuality(nQuality);
	m_Font.SetColor(rgb);
	m_Font.SetBackColor(bk);


//----------------------------ǉ
	// cϊ
	{
		LONG width, height;
		GetSize(width, height);
		ULONG lDstWidth2 = d_dib2.GetWidth();
		for (int y=0;y<sy;y++) {
			DWORD *lpdw = (DWORD*)(GetPtr() + 4*(width - y -1));	// ̏と͏c̉E
			DWORD *lpdw2 = (DWORD*)(d_dib2.GetPtr() + 4*(lDstWidth2 * y));
			for (int x=0;x<sx;x++) {
				*lpdw = *lpdw2;
				lpdw+=width;	// P
				lpdw2++;
			}
		}
	}

	// ěɖ߂
	m_Font.SetShadowOffset(nOx, nOy);
//----------------------------


//	*GetYGA() = true;	//	for BltNatural

	return 0;
}

//	̃RsyOOG
inline LRESULT CTextDIBitmap::UpdateTextVerticalAA(){	//	A`Ft`
	int sx,sy;
	m_Font.GetSize(sx,sy);
//----------------------------ύX
	//	if (CreateSurface(sx,sy)) return 1;
	if (CreateSurface(sy,sx,32,true)) return 1;	// tɂȂ
	//@wiFœhԂ
	//	ȂƏkT[tFXRs[ɃS~̂
	//GetSurfaceInfo()->GeneralEffect(CSurfaceInfo::eSurfaceFill, NULL);
	Clear();
//----------------------------

	COLORREF rgb = m_Font.GetColor();
	COLORREF bk	 = m_Font.GetBackColor();

	m_Font.SetBackColor(CLR_INVALID);
	m_Font.SetColor(RGB(255,255,255));	//	ɂ
	int	nQuality = m_Font.GetQuality();
	m_Font.SetQuality(4);	//	A`Fŏ
	int nFontSize = m_Font.GetSize();
	int nFontHeight = m_Font.GetHeight();
	m_Font.SetSize(nFontSize<<2);	//	4{TCYŕ`
	m_Font.SetHeight(nFontHeight<<2); //@sԂ4{TCYŕ`

	CDIBitmap d_dib;
	int sx2,sy2;
	m_Font.GetSize(sx2,sy2);
	// m_Font̃eLXgłv[D
	if ((sx2 == 0) || (sy2 == 0)) {
		sx2 = sy2 = 1;
	}
	if (d_dib.CreateSurface(sx2,sy2,32,true)) return 2;
	// wiFœhԂ
	d_dib.GetSurfaceInfo()->SetFillColor(GetSurfaceInfo()->GetFillColor());
	//d_dib.GetSurfaceInfo()->GeneralEffect(CSurfaceInfo::eSurfaceFill, NULL);
	d_dib.Clear();
	m_Font.OnDraw(d_dib.GetDC(),m_nTextX<<2,m_nTextY<<2);	//	4{̃tHgTCYŕ`


//----------------------------ǉ
	// ěcpɕύX
	int nOx, nOy;
	m_Font.GetShadowOffset(nOx, nOy);
	m_Font.SetShadowOffset(nOy, -nOx);

	// cϊpɂT[tFX쐬
	CDIBitmap d_dib2;
	if (d_dib2.CreateSurface(sx,sy,32,true)) return 2;
	// wiFœhԂ
	d_dib2.GetSurfaceInfo()->SetFillColor(GetSurfaceInfo()->GetFillColor());
	//d_dib2.GetSurfaceInfo()->GeneralEffect(CSurfaceInfo::eSurfaceFill, NULL);
	d_dib2.Clear();
//----------------------------


	//	S~S{ɏk
	{
	  sx2>>=2; sy2>>=2;
	  if (sx2<sx) { sx = sx2; }	//@ȂHꂽv[^Q̂ق...
	  if (sy2<sy) { sy = sy2; }
	  DWORD dwColor = ((rgb & 0xff) << 16) + (rgb & 0xff00) + ((rgb & 0xff0000)>>16);	//	]u
	
	  ULONG lDstWidth = d_dib.GetWidth();
	  ULONG lDstWidth2 = d_dib2.GetWidth();
	  for(int y=0;y<sy;y++){
//----------------------------ύX
	//	DWORD *lpdw = GetPtr() + (GetRect()->right * y);
		DWORD *lpdw = (DWORD*)(d_dib2.GetPtr() + (4*lDstWidth2 * y));	// cϊp̂̂g
//----------------------------
		DWORD *lpdw2a = (DWORD*)(d_dib.GetPtr() + (4*lDstWidth * (y*4	 )));
		DWORD *lpdw2b = (DWORD*)(lpdw2a		   +  lDstWidth); // C
		DWORD *lpdw2c = (DWORD*)(lpdw2b		   +  lDstWidth); // C
		DWORD *lpdw2d = (DWORD*)(lpdw2c		   +  lDstWidth); // C
		//	ꂽ邳`lɎĂ
		for(int x=0;x<sx;x++){
			DWORD dwAlpha;
			dwAlpha =	((*lpdw2a)&0xff) + ((*(lpdw2a+1))&0xff) + ((*(lpdw2a+2))&0xff) + ((*(lpdw2a+3))&0xff);
			dwAlpha +=	((*lpdw2b)&0xff) + ((*(lpdw2b+1))&0xff) + ((*(lpdw2b+2))&0xff) + ((*(lpdw2b+3))&0xff);
			dwAlpha +=	((*lpdw2c)&0xff) + ((*(lpdw2c+1))&0xff) + ((*(lpdw2c+2))&0xff) + ((*(lpdw2c+3))&0xff);
			dwAlpha +=	((*lpdw2d)&0xff) + ((*(lpdw2d+1))&0xff) + ((*(lpdw2d+2))&0xff) + ((*(lpdw2d+3))&0xff);
			*lpdw = ((dwAlpha << (24-4)) & 0xff000000) + dwColor;	//	F́ArgbŎw肳ꂽF
			lpdw++; lpdw2a+=4; lpdw2b+=4; lpdw2c+=4; lpdw2d+=4;
		}
	  }
	}

	//	AOOG@Ȃ񂬂ȁ[i΁j
	m_Font.SetSize(nFontSize);
	m_Font.SetHeight(nFontHeight);
	//	Ŗ߂ȂƁẢe𐶐ƂɉR̃tHgTCYɂȂ܂OOG

	//	̉e
	if (bk!=CLR_INVALID) {
	//	e񂩁DDD炵ȂOOG
		CTextDIBitmap dib;
		*dib.GetFont() = *GetFont();	//	tHg܂邲ƃRs[Ă܂[IIOOG
		dib.GetFont()->SetColor(bk);
		dib.GetFont()->SetBackColor(CLR_INVALID);	//	CLR_INVALIDɂĂ΁A̍ċA͂QxڂŒ~
//		dib.GetFont()->SetText(m_Font.GetText());
//		dib.SetTextPos(2,2);	//	炵ĕ`I
		{
			int nOx, nOy;
			dib.GetFont()->GetShadowOffset(nOx,nOy);
			dib.SetTextPos(nOx,nOy); // 炵ĕ`I
		}
		dib.UpdateTextAA();

		//	PhotoShop̃CIsxt
		int alpha;
		int beta;
		int total;
		DWORD dwRGB;

		//	dibɂ炽ɕ`悳ƃTCYقȂ邩mȂDD

		ULONG lDstWidth = dib.GetWidth();
		ULONG lDstWidth2 = d_dib2.GetWidth();
		for(int y=0;y<sy;y++){
//----------------------------ύX
		//	DWORD *lpdw = GetPtr() + (GetRect()->right * y);
			DWORD *lpdw = (DWORD*)(d_dib2.GetPtr() + (4*lDstWidth2 * y));	// cϊp̂̂g
//----------------------------
			DWORD *lpdw2 = (DWORD*)(dib.GetPtr() + (4*lDstWidth * y));
			//	ꂽ邳`lɎĂ
			for(int x=0;x<sx;x++){
				/*
				̃ASYɂẮA˂炨̃z[y[W
				X[p[vO}[ւ̓@uCB@PhotoShop̃CASYɂāiYGAtH[}bg񏥂) 00/10/18v
				QƂ̂
				*/
				alpha = *lpdw >> 24;
				beta  = *lpdw2 >> 24;
				beta  = (255-alpha)*beta / 255;	//	GlM[cʂ̌vZ
				//	z䗦܂̂ŁAɊÂĕz
				total = alpha + beta;
				if (total != 0){	//	[̂Ƃ́ARȂėǂ
					if (beta == 0){		//]悪OȂÂ܂ܓ]
						*lpdw2 = *lpdw;
					}else{
						dwRGB = ((*lpdw & 0xff) * alpha + (*lpdw2 & 0xff) * beta) / total;
						dwRGB += (((*lpdw & 0xff00) * alpha + (*lpdw2 & 0xff00) * beta) / total) & 0xff00;
						dwRGB += (((*lpdw & 0xff0000) * alpha + (*lpdw2 & 0xff0000) * beta) / total) & 0xff0000;
						dwRGB += total << 24;	//	alphaĺAGlM[
						*lpdw = dwRGB;
					}
				}
				lpdw++; lpdw2++;
			}
		}
	}

	//	AOOG@Ȃ񂬂ȁ[Qi΁j
	m_Font.SetQuality(nQuality);
	m_Font.SetColor(rgb);
	m_Font.SetBackColor(bk);


//----------------------------ǉ
	// cϊ
	{
		LONG width, height;
		GetSize(width, height);

		ULONG lDstWidth2 = d_dib2.GetWidth();

		for (int y=0;y<sy;y++) {
			DWORD *lpdw = (DWORD*)(GetPtr() + 4*(width - y -1));	// ̏と͏c̉E
			DWORD *lpdw2 = (DWORD*)(d_dib2.GetPtr() + 4*(lDstWidth2 * y));
			for (int x=0;x<sx;x++) {
				*lpdw = *lpdw2;
				lpdw+=width;	// P
				lpdw2++;
			}
		}
	}

	// ěɖ߂
	m_Font.SetShadowOffset(nOx, nOy);
//----------------------------


//	*GetYGA() = true;	//	for BltNatural

	return 0;
}

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd
