// MouseInput.h :
//	}EX͗p
//		programmed by yaneurao(M.Isozaki) '99/7/31
//
//	NXł͂ȂB:p
//
//		@_uNbN̊m͂ȂB
//

#ifndef __yaneMouseInput_h__
#define __yaneMouseInput_h__


#include "../Window/yaneWinHook.h"

namespace yaneuraoGameSDK3rd {
namespace Input {

class IMouse {
public:
	virtual LRESULT GetXY(int &x,int &y)const=0;
	virtual LRESULT GetZ(int &z)const=0;
	virtual bool	RButton()const=0;
	virtual bool	LButton()const=0;
	virtual bool	MButton()const=0;
	virtual LRESULT GetInfo(int &x,int &y,int &b)const=0;
	virtual void	GetButton(bool&bL,bool&bR,bool&bM)=0;
	virtual void	ResetButton()=0;
	virtual LRESULT SetXY(int x,int y)=0;
	virtual void	SetOutScreenInput(bool bEnable)=0;

	virtual ~IMouse(){}
};

class CMouse : public IWinHook,public IMouse {
/**
	}EX̃A^CԎ擾p̃NXłB

	săEBhDĂKv̂
	class CAppFrame hNXŎgp悤ɂĂB
*/
public:
	virtual LRESULT GetXY(int &x,int &y)const;
	///		}EX|WV𓾂iNCAgWnɂāj

	virtual LRESULT GetZ(int &z)const;
	///		zC[̈ړʂ𓾂

	virtual bool	RButton()const;
	///		E{^Ԃ𓾂ĩ݂A^C̏j

	virtual bool	LButton()const;
	///		{^Ԃ𓾂ĩ݂A^C̏j

	virtual bool	MButton()const;
	///		{^Ԃ𓾂ĩ݂A^C̏j

	virtual LRESULT GetInfo(int &x,int &y,int &b)const;
	///	}EX|WVƃ{^ԂԂ
	///	(b:E{^Ȃ+1,{^Ȃ+2,{^Ȃ+4 SĂȂ+1+2+4==+7)

	virtual void	GetButton(bool&bL,bool&bR,bool&bM);
	///	OGetButton牟ꂽH
	virtual void	ResetButton();
	///	GetButtonŎ擾ł{^Ԃ̃Zbg

	virtual LRESULT SetXY(int x,int y);
	///	}EXw̃|WVɈړiNCAgWnɂāj

	virtual void	SetOutScreenInput(bool bEnable);
	/**
		܂܁A}EXʊOɂƂAǂȂ̂H
			true  == {^͉܂܂ƌȂ
			false == {^͗ꂽ̂ƌȂ
			defaultłfalse
	*/

	CMouse();
	virtual ~CMouse();

protected:
	LRESULT WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam); // bZ[W̃R[obN

	bool	m_bRB;					//@}EX{^
	bool	m_bLB;
	bool	m_bMB;
	bool	m_bHistRB;				//	
	bool	m_bHistLB;
	bool	m_bHistMB;
	bool	m_bOutScreenInput;		//	ʊOł̓
	mutable int m_nZ;				//@zC[̏
	unsigned int m_InteliiWheelMsg;	//	zC[Cxgp
};

class CFixMouse : public IMouse {
/**
	}EX̃A^C̎擾̂߂̃NXł

	Q[CMousegꍇAPt[̊Ԃ́A
	ŒlԂĂق]܂B

	class CTimer ɑ΂ CFixTimer ̊֌WƓłB
*/
public:
	///	tbV
	virtual LRESULT	Flush();
	/**
		}EX̍WA{^ԂXVB
		uԂ̏ԂɊÂĊeo֐ŒlԂ悤ɂȂB
		Ƃ͂قƂǁAclass CMouse ƓBA
	*/

	virtual LRESULT GetXY(int &x,int &y)const;
	virtual LRESULT GetZ(int &z)const;
	virtual bool	RButton()const;
	virtual bool	LButton()const;
	virtual bool	MButton()const;
	virtual LRESULT GetInfo(int &x,int &y,int &b)const;

	///	OFlush牟ꂽH
	virtual void	GetButton(bool&bL,bool&bR,bool&bM);
	virtual bool	IsPushRButton()const;
	virtual bool	IsPushLButton()const;
	virtual bool	IsPushMButton()const;

	///	OFlush牟グꂽH
	virtual void	GetUpButton(bool&bL,bool&bR,bool&bM);
	virtual bool	IsPushUpRButton()const;
	virtual bool	IsPushUpLButton()const;
	virtual bool	IsPushUpMButton()const;

	virtual void	ResetButton();
	///	{^ԃZbg

	virtual LRESULT SetXY(int x,int y);
	///	}EXw̃|WVɈړiNCAgWnɂāj
	///	ōWړꍇAFlushȂƂGetXY΂̍WԂB

	/**
		K[h^CƂ́AV[ǗĂ肷ƂA{^āA
		̃V[ɈړāÃV[łȂ{^ꂽƔ肳
		܂Ƃh~邽߂ɁA莞ԁu͂vƉRԂ߂
		@\łBSetGuardTimeŐݒ肵Flusho֐Ăяo܂ł́A
		GetButton/IsPushRButton/IsPushLButtonłׂ͂ă{^
		ĂȂƕԂ܂B
	*/
	///	K[h^CǂԂ
	virtual bool	IsGuardTime()const;
	///	K[h^Cݒ肷
	void	SetGuardTime(int nTime);

	virtual void	SetOutScreenInput(bool bEnable)
		{ GetMouse()->SetOutScreenInput(bEnable);}

	CFixMouse();
	virtual ~CFixMouse();

protected:
	bool	m_bRBN;					//@FlushƂ̃}EX{^
	bool	m_bLBN;
	bool	m_bMBN;
	int		m_nRLMBN;				//	FlushƂ̃}EX{^
	int		m_nX,m_nY,m_nZ;			//	FlushƂ̃}EX̃|WV
	int		m_nGuardTime;			//	K[h^C
	bool	m_bHistRB;				//	
	bool	m_bHistLB;
	bool	m_bHistMB;

	CMouse	m_vMouse;				//	ɈϏ
	CMouse* GetMouse() { return &m_vMouse; }
};

} // end of namespace Input
} // end of namespace yaneuraoGameSDK3rd

#endif
