//	yaneVirtualKey.h :
//		Virtual Key Class for CKeyBase
//				programmed by yaneurao(M.Isozaki) '99/11/13
//

#ifndef __yaneVirtualKey_h__
#define __yaneVirtualKey_h__


#include "yaneKeyBase.h"

namespace yaneuraoGameSDK3rd {
namespace Input {

const int g_VIRTUAL_KEY_MAX=88;	//	zL[̍ői88:pj

class CVirtualKey : public IKeyBase {
/**
	L[̓NXBCKeyBase̔hNX𗘗pāA
	ЂƂ܂Ƃ߂ɂĊǗłB

	Ƃ΁AL[{[h́L[ƁAeL[̂WL[A
	WCXeBbŃ͂A̉zL[Ƃēo^邱ƂɂāA
	̂ǂꂩ͂Ă邩A֐ЂƂĂяo
	ł悤ɂȂB

	ۂclass CKey,class CKey2́A
	̃NX̉pȂ̂ŁAQƂ邱ƁB

	S̓Iȗ́AL[foCX̓o^zL[̐ݒƂĂāA
	Input̂IsVKeyPress/IsVKeyPushŔłB
*/
public:
	CVirtualKey();
	virtual ~CVirtualKey();

	///	L[foCX̓o^
	/**	L[foCXƂ́ACKeyBase̔hNX̃CX^XB
		̓IɂCDirectInput,CMIDIInput,CJoyStick̃CX^X
		B͂L[foCX܂o^B
		InputĂяoƂɂāAGetStateĂяoB
	*/
	void	ClearKeyDevice();			///	foCX̃NA
	void	AddDevice(const smart_ptr<IKeyBase>&);		///	foCX̒ǉ
	void	RemoveDevice(const smart_ptr<IKeyBase>&);	///	foCX̍폜
	smart_ptr<IKeyBase> GetDevice(int n);	///	Ԗڂɓo^foCX̎擾
	/**
		̊֐g΂ԖځiOn܂jAddDevicefoCX
		擾łBj
	*/

	///	zL[̒ǉE폜
	void	ClearKeyList();							///	zL[̃Zbg
	void	AddKey(int vkey,int nDeviceNo,int key);		///	zL[̒ǉ
	void	RemoveKey(int vkey,int nDeviceNo,int key);	///	zL[̍폜
	/**
		vkeýAzL[ԍB0`VIRTUAL_KEY_MAX-1
		(88defineĂ)Ԃ܂œo^\B
		L[foCXnDeviceNóAGetDeviceŎw肷io[Ɠ́B
		keýÃL[foCXkeyio[B
	*/

	///	----	overriden from IKeyBase	 ------

	virtual LRESULT	Input();
	///@o^ĂfoCXǂ݂

///	virtual bool	IsKeyPress(int vkey);		///	zL[𒲂ׂ
///	virtual bool	IsKeyPush(int vkey);		///	zL[𒲂ׂ
/**
	zL[vkeyĂ邩ǂ𒲂ׂB
	IsKeyPresŝق́A݉ĂtrueBIsKeyPush́A
	O񉟂ĂȂāA񉟂ĂtrueB
*/

///	virtual const BYTE*	GetKeyData() const;
	/// 擾L[(BYTE m_byKeyBuffer[256])ւ̃|C^𓾂)
	///	ڃ|C^𓾂Ă肮肷l̂߂ɁOOG

protected:
	class CKeyInfo {
	public:
		int			m_nDeviceNo;
		int			m_nKey;
	};
	typedef smart_vector_ptr<CKeyInfo> CVKeyList;
	CVKeyList	m_VKey[g_VIRTUAL_KEY_MAX];			//	zL[Xg

	smart_vector_ptr<IKeyBase>	m_alpDevice;		//	̓L[foCXXg
};

} // end of namespace Input
} // end of namespace yaneuraoGameSDK3rd

#endif
