//
//	yaneSoundLoader.h :
//
//		TEh̓I[fBO
//

#ifndef __yaneSoundLoader_h__
#define __yaneSoundLoader_h__


#include "../Auxiliary/yaneLoadCache.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

class ISound;
class ISoundFactory;

class CSoundLoader : public CLoadCache {
/**
	class ISound hNX̂߂ LoadCache
*/
public:
	virtual smart_ptr<ISound> GetSound(int nNo);		///	TEh̎擾

	///	ΐݒ肵Ă[I
	///	StreamSoundōĐ邩ǂ̃|V[ꂪ֗^Ƃ
	void	SetSoundFactory(const smart_ptr<ISoundFactory>& sf) { m_sf = sf; }
	smart_ptr<ISoundFactory> GetSoundFactory() const { return m_sf; }

	///	StreamPlayIɗL^ɂ邽߂̃IvV
	///	(CSoundFactorył̐ݒD悳)
	void	SetStreamPlay(bool bStreamPlay)
	{
		m_bEnforceStreamPlay = true;
		m_bStreamPlay = bStreamPlay;
	}

	///	nNõt@C擾
	string	GetFileName(int nNo);

	CSoundLoader():m_bEnforceStreamPlay(false){}

protected:
	smart_ptr<ISoundFactory> m_sf;
	virtual	LRESULT InnerLoad(const smart_obj& obj);
	bool m_bEnforceStreamPlay;
	bool m_bStreamPlay;
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif