// yaneWaveStaticSound.h
//		programmed by yaneurao(M.Isozaki) '99/07/07
//		reprogrammed by yaneurao '00/03/04

#ifndef __yaneWaveStaticSound_h__
#define __yaneWaveStaticSound_h__


#include "yaneSound.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

class IWaveOutput;
class ISoundBuffer;
class CWaveStaticSound : public IWaveSound {
/**
	WaveĐ̂߂ class ISound hNX
	ۂclass CWaveSoundʂėp
	class CWaveStreamSound ƈႢAt@CۂƓǂōĐ
*/
public:
	CWaveStaticSound(IWaveOutput* p);
	virtual ~CWaveStaticSound();

	/// override from class ISound
	LRESULT Open(const string& strFileName) { return Load(strFileName); }
	LRESULT Close()	{ return Release(); }
	LRESULT Play();
	LRESULT Replay();
	LRESULT Stop();
	LRESULT Pause();
	bool	IsPlay() const;
	LRESULT	SetLoopPlay(bool bLoop);
	bool	IsLoopPlay() const { return m_bLoop; }
	LONG	GetLength() const { return m_lLength; }
	LRESULT SetCurrentPos(LONG lPos);
	LONG	GetCurrentPos() const;
	LRESULT SetVolume(LONG volume);
	LONG	GetVolume() const;
	string	GetFileName() const { return m_strFileName; }
	int	GetType() const { return 3; }

	/// override from class IWaveSound
	LRESULT Restore();

	/// t@Cǂݍ
	LRESULT Load(const string& strFileName);

	/// t@C
	LRESULT Release();

	/// Đg̎擾
	LRESULT SetFrequency(DWORD freq);

	/// Đg̐ݒ
	LONG	GetFrequency() const;

	//////////////////////////////////////////////////////////////////////////

protected:
	smart_ptr<ISoundBuffer> m_vBuffer;			//	ZJ_obt@
	smart_ptr<ISoundBuffer> GetBuffer() const { return m_vBuffer; }
	void SetBuffer(smart_ptr<ISoundBuffer> v) { m_vBuffer = v; }

	string	m_strFileName;						//	t@C
	int		m_bPaused;							//	TEhpauseH
	bool	m_bLoop;							//	[v[hōĐ̂H
	DWORD	m_nAvgBytesPerSec;					//	bԂ̃f[^oCgiĐʒuZopj
	LONG	m_lLength;

	IWaveOutput*	GetOutput() const { return m_pOutput; }
	IWaveOutput*	m_pOutput;
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif // __yaneWaveStaticSound_h__
