/**
	Javaobject lock/synchronizedT|[g邽߂̃NX

		programmed by M.Isozaki(yaneurao) '02/07/15

*/
#ifndef __yaneLockObject_h__
#define __yaneLockObject_h__


#include "../Thread/yaneEvent.h"

namespace yaneuraoGameSDK3rd {
namespace Thread {

class CLockObject {
/**
	javaobject lock/synchonizedT|[g邽߂̃NX

	ۂ̎gɂĂJavaThread֌W̖{ǂނA
	class CThreadManager ̎QlɂׂB
*/
public:

	LRESULT	wait(int nTimeOut=-1);
	/**
		wait L[ɕ
		PDAĂяoOɂcritical locklĂȂ
			ȂȂBȂ킿AGetCriticalSection()->Enter()
			ĂяoĂԂłȂ΂ȂȂB

			bNĂȂ
				CIllegalMonitorStateException
			OB

		QDԑOɃXbh́A
			񎩕critical lockB
		RD҂́AXbh
			notify / notifyAllĂяo܂ő
			CThreadɑ΂āAinterruptĂяoꂽƂ
			҂甲@ˁ@CThread::interruptQƁj
		SDOɁAēxcritical locksȂ

		TDnTiméÃ^CAEgԂwłB[ms]PʁB
			-1Ȃendlessinotify / notifyAll܂ő҂j

		ԂlF
			0 : Xbhɂnotify / notifyAllꂽ
			1 : ^CAEgɂȂ
		//	2 : 肦Ȃ͂ACEventԂ\
			(FsȂ)
	*/

	void	notify();
	/// waitő҂ĂXbh@N(1̂)

	void	notifyAll();
	/// waitő҂Ă邷ׂẴXbh@N

	///////////////////////////////////////////////////////////////////
	//	܂

	void	eraseThreadInWaitList(DWORD dwThreadID);
	/**
		҂XbhXĝȂAw肳ꂽXbhƓ
		XbhID̂
		ǐĂяoɐsăbNlĂȂ΂ȂȂj
			lĂȂꍇCIllegalMonitorStateException

		ӂ́AĂяoƂ͖i͂j
	*/

	void	notifyThreadInWaitList(DWORD dwThreadID);
	/**
		҂XbhXĝȂAw肳ꂽbhƓ
		XbhID̂ɑ΂āASetEventsȂ
	*/

public:
	ICriticalSection* GetCriticalSection() { return& m_cs;}
	/**
		̃IuWFNgɑ΂critical lock
		j
			CLockObject o;
			CCriticalLock cl(o.GetCriticalSection());
			{
				Ȃ₩
			}
		Ƃ΁AuȂ₩v̏̕atomiciXbh
		זȂjɂȂ
	*/

	struct CWaitState {
	/**
		waitő҂ĂXbh\邽߂̍\
	*/
		void	SetThreadId(DWORD dwThreadID) { m_dwThreadID = dwThreadID; }
		DWORD	GetThreadId() const { return m_dwThreadID; }
		/**
			̑҂ĂXbhݒ^擾
			Őݒ肳ĺAuniquełΕʂ::GetThreadIdŎ擾
			olłȂƂǂB
		*/

		IEvent* GetEvent() { return &m_vEvent; }
		///	҂̂߂̃Cxg

		CWaitState() : m_bInterrupt(false),m_dwThreadID((DWORD)-1) {}
	private:
		CEvent	m_vEvent;	//	҂ĂCxgXg
		bool	m_bInterrupt;
		DWORD	m_dwThreadID;
	};

	smart_vector_ptr<CWaitState>* GetWaitThreadList()
		{ return &m_WaitThreadList; }

protected:
	CCriticalSection m_cs;
	smart_vector_ptr<CWaitState> m_WaitThreadList;
	//	Ƃ́ACriticalLockK̂ŁA
	//	volatilełKv͖

};

struct synchronized {
/**
	CLockObjectɑ΂javasynchronized
	g

	void test(){
		synchronized g(&lock);
		//	̃\bh͋[IsynchronizedɂȂ
	}
	CLockObject lock;
*/
	synchronized(CLockObject*lock) {
		cs_ = lock->GetCriticalSection();
		cs_->Enter();
	}
	synchronized(CLockObject& lock) {
		cs_ = lock.GetCriticalSection();
		cs_->Enter();
	}	
	synchronized(ICriticalSection*cs) {
		cs_ = cs;
		cs_->Enter();
	}
	synchronized(CCriticalSection& cs) {
		cs_ = &cs;
		cs_->Enter();
	}

	///	CriticalSectionenter`leave𖾎IɍsȂp̃\bh
	void lock(){ cs_->Enter(); }
	void unlock() { cs_->Leave(); }

	~synchronized(){
		cs_->Leave();
	}

protected:
	ICriticalSection* cs_;
};

} // end of namespace Thread
} // end of namespace yaneuraoGameSDK3rd

#endif
