// yaneTimer.h :
//
//	CTimer			:	oߎԂJEg^C}
//
//		programmed by yaneurao(M.Isozaki) '99/07/25
//		modified by yaneurao '00/02/28-'00/03/13
//

#ifndef __yaneTime_h__
#define __yaneTime_h__


namespace yaneuraoGameSDK3rd {
namespace Timer {

class CTimeGetTimeWrapper {
/**
	btimeGetTimewrapper

	timeGetTimegȂ󋵂ɒuẮA
	GetTickCountg悤ɐݒ肷

	̃RXgN^`fXgN^
	timeBeginPeriodMintimeEndPeriodMin
	ĂяoĂ
	
	̃IuWFNgref_createrŗpB
	(singletonłǂ̂..)
*/
public:

	DWORD	GetTime() {
		///	̃^C}̎擾
		if (m_bUseTGT) {
			return ::timeGetTime();
		} else {
			return ::GetTickCount();
		}
	}

	CTimeGetTimeWrapper();
	virtual ~CTimeGetTimeWrapper();

	static	ref_creater<CTimeGetTimeWrapper>*	GetRefObj()
		{ return & m_vTimeGetTime; }

protected:
	bool		m_bUseTGT;		//	timeGetTimegp̂H
	int			m_nRef;			//	timeBeginPeriodMin`timeEndPeriodMin̎QƃJEg
	TIMECAPS	m_dwTimeCaps;	//	^C}[\

	static	ref_creater<CTimeGetTimeWrapper>	m_vTimeGetTime;
};

//////////////////////////////////////////////////////////////////////////////

class ITimer {
public:
	virtual void	Reset()=0;			///	݂̎O
	virtual DWORD	Get()=0;			///	݂̎̎擾
	virtual void	Set(DWORD)=0;		///	݂̎̐ݒ
	virtual void	Pause()=0;			///	Pause@\
	virtual void	Restart()=0;		///	Pause
	virtual ~ITimer() {}
};

class CTimer : public ITimer {
/**
	bAƗ^C}B
	Reset()ƁA^C}ZbgAȍ~AGet()ĂяoƁA
	OAReset()ꂽƂ̌oߎԁi[ms]PʁjԂĂ悤ɂȂB
*/
public:
	virtual void	Reset();			///	݂̎O
	virtual DWORD	Get() ;				///	݂̎̎擾
	virtual void	Set(DWORD);			///	݂̎̐ݒ
	virtual void	Pause();			///	Pause@\
	virtual void	Restart();			///	Pause

	CTimer();
	virtual ~CTimer();

protected:
	DWORD	m_dwOffsetTime;					//	ItZbgl
	DWORD	m_dwPauseTime;					//	PauseƂTime
	int		m_bPaused;						//	pauseH

private:
	static	ref_creater<CTimeGetTimeWrapper>*	GetRefObj()
	{ return CTimeGetTimeWrapper::GetRefObj(); }
	static	CTimeGetTimeWrapper*	GetObj()
	{ return GetRefObj()->get(); }
};

//////////////////////////////////////////////////////////////////////////////

class CFixTimer : public ITimer {
/**
	Q[ class CTimer gꍇA
	Pt[̊Ԃ́AŒlԂĂق]܂B

	class CMouse ɑ΂ class CMouseEx Ɠ֌WłB
	Flush֐̐ǂނƁB
*/
public:
	virtual void	Reset();			///	݂̎O
	virtual DWORD	Get();				///	݂̎̎擾
	virtual void	Set(DWORD);			///	݂̎̐ݒ
	virtual void	Pause();			///	Pause@\
	virtual void	Restart();			///	Pause

	virtual	void	Flush();
	/**
		XVB
		uԂ̎lɊÂGetŒlԂ悤ɂȂB
		ȍ~Aēx̊֐Ăяo܂ŁAFlushƓlԂ
		̊֐ȊÓAclass CTimer Ɠ
	*/

	CFixTimer();

protected:
	CTimer	m_vTimer;
	DWORD	m_dwTimeGetTime;				//	OFlush

	CTimer* GetTimer() { return& m_vTimer; }
};

} // end of namespace Timer
} // end of namespace yaneuraoGameSDK3rd

#endif
